;TITLE BIRTHDAY
;AUTHOR entropy
;COMMANDS birthday(0)
;VERSION: 1.3
;HELP birthday [month] [day] [year]|Displays days past since month day and year.|none

;============================== ALIASES
alias -l compressedtime {
  return $remove($replace($duration($calc($ctime - $1)),wks,w,wk,w,days,d,day,d,hrs,h,hr,h,mins,m,min,m,secs,s,sec,s),$chr(32))
}
alias -l birthday {
  var %a = $+(birthday.,$r(1,999999999999999999999999999))
  sockopen %a www.timeanddate.com 80
  sockmark %a $remove($1-,$chr(44))
  hdel $1 birthdayfound
}
alias -l sortbirthday {
  var %a = 1, %b = $1-, %c, %d, %d2
  while ($gettok(%b,%a,32)) {
    %c = $ifmatch
    if (%c == is) { %d = $calc(%a + 1) }
    elseif (%c == from) { %d2 = $calc(%a - 1) }
    inc %a
  }
  return $gettok(%b,$+(%d,-,%d2),32)
}

alias -l striphtml {
  var %p = 1, %b = $replace($1-,$chr(38),$+($chr(32),$chr(38)),;,$+(;,$chr(32)),>,$+(>,$chr(32)),<,$+($chr(32),<,)), %c
  while ($gettok(%b,%p,32)) {
    %c = $ifmatch
    if (*<* iswm %c || *&*; iswm %c || *</* iswm %c || *solid* iswm %c || *px* iswm %c || *:* iswm %c && $remove(%c,:) !isnum || */* iswm %c || *'* iswm %c || *;* iswm %c || *&* iswm %c || *<*>* iswm %c || *=* iswm %c || *"* iswm %c || *>* iswm %c || $+(*,$chr(40),*) iswm %c || $+(*,$chr(41),*) iswm %c || $+(*,$chr(123),*) iswm %c || $+(*,$chr(125),*) iswm %c) { %b = $remove(%b,%c) | %p = 0 }
    inc %p
  }
  return %b
}
alias -l endbirthday {
  var %t = $gettok($hget(cgsb,$+($1,.colors)),1,32), %u = $gettok($hget(cgsb,$+($1,.colors)),2,32)
  sockwrite -n $1 privmsg $hget($1,birthdaychannel) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ Birthday: $2- Age: $hget($1,age) $iif($calc($findtok($hget($1,age),days,1,32) - 1) > 2 && $hget($1,days),$+($chr(40),$hget($1,days),$chr(41))) Next: $hget($1,next) $chr(3)
}
alias -l birthday2 {
  var %a = $+(birthday2.,$r(1,999999999999999999999999999))
  sockopen %a www.timeanddate.com 80
  sockmark %a $remove($1-,$chr(44))
}
alias -l cgsbsock { return $hget(cgsb,socket) | halt }

;============================== EVENTS
on *:signal:birthday:{
  var %z = $hget(cgsb,buffer), %p = $hget(cgsb,$+($cgsbsock,.prefix))
  var %t = $gettok($hget(cgsb,$+($cgsbsock,.colors)),1,32), %u = $gettok($hget(cgsb,$+($cgsbsock,.colors)),2,32)
  var %a = $hget($cgsbsock,access)
  tokenize 32 %z
  if ($2 == privmsg && $left($3,1) == $chr(35) && $+(:,%p,*) iswm $4) {
    if ($+(:,%p,birthday) == $4) {
      if (%a < $getcom(birthday)) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ You do not posses enough access for this command. $chr(3) | return }
      var %f = $hget($cgsbsock,$+($gettok($mid($1,2,$len($1)),1,33),.birthday))
      var %m = $iif($5-,$5-7,%f)
      var %m = $replace(%m,january,1,jan,1,february,2,feb,2,march,3,mar,3,april,4,apr,4,may,5,june,6,jun,6,july,7,jul,7,august,8,aug,8,september,9,sept,9,october,10,oct,10,november,11,nov,11,december,12,dec,12)
      if (!$7 && !%f) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u))) Unable to comply, you must specify the month, day and year. eg: 02 05 1986 (month/day/year format) $chr(3) | return }
      hadd $cgsbsock $+($gettok($mid($1,2,$len($1)),1,33),.birthday) %m
      hadd $cgsbsock birthdaychannel $3
      hadd $cgsbsock birthdaynick $gettok($mid($1,2,$len($1)),1,33)
      birthday $cgsbsock %m
      sockwrite -n $cgsbsock silence $+(+,$gettok($mid($1,2,$len($1)),1,33))
      .timer -o 1 5 sockwrite -n $cgsbsock silence $+(-,$gettok($mid($1,2,$len($1)),1,33))
    }
  }
  elseif ($2 == join && $hget(cgsb,$+($cgsbsock,.nick)) != $gettok($mid($1,2,$len($1)),1,33)) {
    var %nick = $gettok($mid($1,2,$len($1)),1,33), %uid = $gettok($gettok($mid($1,2,$len($1)),2,33),1,64), %host = $gettok($mid($1,2,$len($1)),2,64), %q = $hget($cgsbsock,$+(%nick,.birthday)), %z = $date(m) $date(d) $date(yyyy)
    if ($gettok(%q,1-2,32) == $gettok(%z,1-2,32)) { sockwrite -n $cgsbsock privmsg $remove($3,:) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ *** Happy Birthday $+(%nick,!) *** $chr(3) }
  }
}
on *:sockopen:birthday.*:{
  var %t = $gettok($hget(cgsb,$+($gettok($sock($sockname).mark,1,32),.colors)),1,32), %u = $gettok($hget(cgsb,$+($gettok($sock($sockname).mark,1,32),.colors)),2,32)
  if ($sockerr > 0) { sockwrite -n $gettok($sock($sockname).mark,1,32) notice $hget($gettok($sock($sockname).mark,1,32),birthdaynick) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ Socket error(s). Try again later. $chr(3) | return } 
  var %m = $gettok($sock($sockname).mark,2,32), %d = $gettok($sock($sockname).mark,3,32), %u = $iif($date(m) < %m,$date(yyyy),$calc($date(yyyy) + 1))
  sockwrite -n $sockname GET $+(http://www.timeanddate.com/date/durationresult.html?m1=,$date(m),&d1=,$date(d),&y1=,$date(yyyy),&m2=,%m,&d2=,%d,&y2=,%u) HTTP/1.1
  sockwrite -n $sockname Host: $+(www.timeanddate.com,$str($crlf, 2))
}
on *:sockread:birthday.*:{
  var %t = $gettok($hget(cgsb,$+($gettok($sock($sockname).mark,1,32),.colors)),1,32), %u = $gettok($hget(cgsb,$+($gettok($sock($sockname).mark,1,32),.colors)),2,32)
  if ($sockerr > 0) { sockwrite -n $gettok($sock($sockname).mark,1,32) notice $hget($gettok($sock(birthday).mark,1,32),.birthdaynick) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ Socket error(s). Try again later. $chr(3) | return }
  var %a
  sockread %a
  %a = $mid(%a,1,800)
  tokenize 32 %a
  if (*<h2>An error occured</h2>* iswm $1-) { hdel $gettok($sock($sockname).mark,1,32) $+($hget($gettok($sock($sockname).mark,1,32),.birthdaynick),.birthday) | sockwrite -n $gettok($sock($sockname).mark,1,32) notice $hget($gettok($sock($sockname).mark,1,32),birthdaynick) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u))) $striphtml($1-) }
  elseif (*<span class="big">*</span>* iswm $1-) {
    hadd $gettok($sock($sockname).mark,1,32) next $remove($gettok($striphtml($1-),$+($findtok($striphtml($1-),Or,1,32),-,$findtok($striphtml($1-),excluding,1,32)),32),Or,excluding) 
    birthday2 $sock($sockname).mark
  }
  elseif (*<span class="bigger">*</span>* iswm $1-) {
    hadd $gettok($sock($sockname).mark,1,32) next $sortbirthday($striphtml($1-))
    birthday2 $sock($sockname).mark
  }
}
on *:sockopen:birthday2.*:{
  var %t = $gettok($hget(cgsb,$+($gettok($sock($sockname).mark,1,32),.colors)),1,32), %u = $gettok($hget(cgsb,$+($gettok($sock($sockname).mark,1,32),.colors)),2,32)
  if ($sockerr > 0) { sockwrite -n $gettok($sock($sockname).mark,1,32) notice $hget($gettok($sock($sockname).mark,1,32),birthdaynick) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u))) Socket error(s). Try again later. $chr(3) | return } 
  var %m = $gettok($sock($sockname).mark,2,32), %d = $gettok($sock($sockname).mark,3,32), %y = $gettok($sock($sockname).mark,4,32), %u = $iif($date(m) < %m,$date(yyyy),$calc($date(yyyy) + 1))
  sockwrite -n $sockname GET $+(http://www.timeanddate.com/date/durationresult.html?m1=,%m,&d1=,%d,&y1=,%y,&m2=,$date(m),&d2=,$date(d),&y2=,$date(yyyy)) HTTP/1.1
  sockwrite -n $sockname Host: $+(timeanddate.com,$str($crlf, 2))
}
on *:sockread:birthday2.*:{
  var %t = $gettok($hget(cgsb,$+($gettok($sock($sockname).mark,1,32),.colors)),1,32), %u = $gettok($hget(cgsb,$+($gettok($sock($sockname).mark,1,32),.colors)),2,32)
  if ($sockerr > 0) { sockwrite -n $gettok($sock($sockname).mark,1,32) notice $hget($gettok($sock($sockname).mark,1,32),birthdaynick) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u))) Socket error(s). Try again later. $chr(3) | return }
  var %a
  sockread %a
  %a = $mid(%a,1,600)
  tokenize 32 %a
  if (*<span class="big">*</span>* iswm $1-) {
    hadd $gettok($sock($sockname).mark,1,32) age $remove($gettok($striphtml($1-),$+($findtok($striphtml($1-),Or,1,32),-,$findtok($striphtml($1-),excluding,1,32)),32),Or,excluding) 
    hadd $gettok($sock($sockname).mark,1,32) days $remove($gettok($striphtml($1-),$+($findtok($striphtml($1-),is,1,32),-,$findtok($striphtml($1-),days,1,32)),32),is)
    hadd $gettok($sock($sockname).mark,1,32) $+($hget($gettok($sock($sockname).mark,1,32),.birthdaychannel)) $+($hget($gettok($sock($sockname).mark,1,32),.birthdaynick),.age) $remove($gettok($striphtml($1-),$+($findtok($striphtml($1-),Or,1,32),-,$findtok($striphtml($1-),excluding,1,32)),32),Or,excluding) 
  }
  elseif (*<span class="bigger">*</span>* iswm $1-) {
    hadd $gettok($sock($sockname).mark,1,32) age $sortbirthday($striphtml($1-))
    hadd $gettok($sock($sockname).mark,1,32) days $remove($gettok($striphtml($1-),$+($findtok($striphtml($1-),is,1,32),-,$findtok($striphtml($1-),days,1,32)),32),is,days)
  }
  $+(.timerbirthday,$gettok($sock($sockname).mark,1,32)) -o 1 1 endbirthday $sock($sockname).mark
}
