;TITLE CONVERT
;AUTHOR entropy
;COMMANDS convert(0)
;VERSION: 1.2
;HELP convert [amount] [from] [to]|Converts to/from the following: AUD CAD CHF CNY DKK EUR GBP HKD HUF INR JPY MXN MYR NOK NZD RUB SEK SGD THB USD ZAR|none

;============================== ALIASES
alias -l compressedtime {
  return $remove($replace($duration($calc($ctime - $1)),wks,w,wk,w,days,d,day,d,hrs,h,hr,h,mins,m,min,m,secs,s,sec,s),$chr(32))
}
alias -l dur {
  return $remove($replace($duration($1),wks,w,wk,w,days,d,day,d,hrs,h,hr,h,mins,m,min,m,secs,s,sec,s),$chr(32))
}
alias -l convert {
  var %a = $r(1,99999)
  sockopen $+(convert.,%a) www.google.com 80
  sockmark $+(convert.,%a) $1-

}

alias -l striphtml {
  var %p = 1, %b = $replace($mid($1-,1,800),$chr(38),$+($chr(32),$chr(38)),;,$+(;,$chr(32)),>,$+(>,$chr(32)),<,$+($chr(32),<,)), %c
  while ($gettok(%b,%p,32)) {
    %c = $ifmatch
    if (*<* iswm %c || *&*; iswm %c || *</* iswm %c || *solid* iswm %c || *px* iswm %c || *:* iswm %c && $remove(%c,:) !isnum || */* iswm %c || *'* iswm %c || *;* iswm %c || *&* iswm %c || *<*>* iswm %c || *=* iswm %c || *"* iswm %c || *>* iswm %c || $+(*,$chr(40),*) iswm %c || $+(*,$chr(41),*) iswm %c || $+(*,$chr(123),*) iswm %c || $+(*,$chr(125),*) iswm %c) { %b = $remove(%b,%c) | %p = 0 }
    inc %p
  }
  return %b
}
alias -l cgsbsock { return $hget(cgsb,socket) | halt }
;============================== EVENTS
on *:signal:convert:{
  var %z = $hget(cgsb,buffer), %p = $hget(cgsb,$+($cgsbsock,.prefix))
  var %t = $gettok($hget(cgsb,$+($cgsbsock,.colors)),1,32), %u = $gettok($hget(cgsb,$+($cgsbsock,.colors)),2,32)
  var %a = $hget($cgsbsock,access)
  tokenize 32 %z
  if ($+(:,%p,convert) == $4) {
    if (%a < $getcom(convert)) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ You do not posses enough access for this command. $chr(3) | return }
    elseif (!$5) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ No amount specified. $chr(3) }
    elseif (!$6) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ No "from" specified $chr(3) }
    elseif (!$7) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ No "to" specified $chr(3) }
    elseif (!$istok(AUD CAD CHF CNY DKK EUR GBP HKD HUF INR JPY MXN MYR NOK NZD RUB SEK SGD THB USD ZAR,$6,32)) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ Invalid "from" currency. Available: AUD CAD CHF CNY DKK EUR GBP HKD HUF INR JPY MXN MYR NOK NZD RUB SEK SGD THB USD ZAR $chr(3) }
    elseif (!$istok(AUD CAD CHF CNY DKK EUR GBP HKD HUF INR JPY MXN MYR NOK NZD RUB SEK SGD THB USD ZAR,$6,32)) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ Invalid "to" currency. Available: AUD CAD CHF CNY DKK EUR GBP HKD HUF INR JPY MXN MYR NOK NZD RUB SEK SGD THB USD ZAR $chr(3) }
    else {
      hadd -m $cgsbsock $+($gettok($mid($1,2,$len($1)),1,33),.chan) $3
      %nick = $gettok($mid($1,2,$len($1)),1,33)
      convert $cgsbsock $gettok($mid($1,2,$len($1)),1,33) $5-
    }
    sockwrite -n $cgsbsock silence $+(+,$gettok($mid($1,2,$len($1)),1,33))
    .timer -o 1 2 sockwrite -n $cgsbsock silence $+(-,$gettok($mid($1,2,$len($1)),1,33))
  }
}
on *:sockopen:convert.*:{
  var %t = $gettok($hget(cgsb,$+($sockname,.colors)),1,32), %u = $gettok($hget(cgsb,$+($sockname,.colors)),2,32)
  if ($sockerr > 0) { sockwrite -n $gettok($sock($sockname).mark,1,32) notice $gettok($sock($sockname).mark,2,32) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u))) Socket error(s). Try again later. $chr(3) | return }
  ;sockwrite -n $sockname GET $+(/ucc/convert.cgi?Amount=,$gettok($sock($sockname).mark,3,32),&From=,$gettok($sock($sockname).mark,4,32),&To=,$gettok($sock($sockname).mark,5,32)) HTTP/1.1
  sockwrite -n $sockname GET $+(/search?hl=en&q=,$gettok($sock($sockname).mark,3,32),+,$gettok($sock($sockname).mark,4,32),+to+,$gettok($sock($sockname).mark,5,32),&btnG=Search) HTTP/1.1


  sockwrite -n $sockname Host: $+(www.xe.com,$str($crlf, 2))
}
on *:sockread:convert.*:{
  var %t = $gettok($hget(cgsb,$+($sockname,.colors)),1,32), %u = $gettok($hget(cgsb,$+($sockname,.colors)),2,32)
  if ($sockerr > 0) { sockwrite -n $gettok($sock($sockname).mark,1,32) notice $gettok($sock($sockname).mark,2,32) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u))) Socket error(s). Try again later. $chr(3) | return }
  var %x
  sockread -f %x
  tokenize 32 %x
  if (*<font size=+1><b>* iswm $1-) {
    var %tmp = $findtok($1-,$wildtok($1-,*size=+1><b>*,1,32),1,32)
    var %end = $findtok($1-,$wildtok($1-,*</b></h2></td></tr><tr><td>&nbsp;</td><td>&nbsp;</td><td><font*,1,32),1,32)
    var %rem = $remove($gettok($1-,$+(%tmp,-,%end),32),size=+1><b>,</b></h2></td></tr><tr><td>&nbsp;</td><td>&nbsp;</td><td><font)
    %tmp = %rem
    %answer = %tmp
  }
  .timerconvert -o 1 1 endconvert $sockname
}
alias -l endconvert {
  var %t = $gettok($hget(cgsb,$+($1,.colors)),1,32), %u = $gettok($hget(cgsb,$+($1,.colors)),2,32)
  if (%answer) { sockwrite -n $gettok($sock($1).mark,1,32) privmsg $hget($gettok($sock($1).mark,1,32),$+($gettok($sock($1).mark,2,32),.chan)) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ Convert: %answer $chr(3) | unset %answer }
  else { sockwrite -n $gettok($sock($1).mark,1,32) notice %nick $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ Nothing found. $chr(3) }
  unset %nick
}
