;TITLE DNS
;AUTHOR entropy
;COMMANDS dns(0)
;VERSION: 1.1
;HELP dns [host/nick/ip/website]|Finds dns results of token.|none

;============================== ALIASES
alias -l botdns {
  var %a = $+(dns.,$r(1,99999999999999999999))
  hdel $1 dnsfound
  sockopen %a cgibin.erols.com 80
  sockmark %a $1-
}
alias -l enddns {
  var %t = $gettok($hget(cgsb,$+($1,.colors)),1,32), %u = $gettok($hget(cgsb,$+($1,.colors)),2,32)
  if (!$hget($1,dnsfound)) {
    sockwrite -n $1 notice $hget($1,dnsnick) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) No results found. $chr(3)
    hdel $1 dnschannel
    hdel $1 dnsnick
  }
  else { sockwrite -n $1 privmsg $hget($1,dnschannel) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ Dns: $2 $iif($remove($hget($1,dnsfound),.) isnum,IP: $hget($1,dnsfound),Host: $hget($1,dnsfound)) $chr(3) }
}
alias -l cgsbsock { return $hget(cgsb,socket) | halt }
;============================== EVENTS
on *:signal:dns:{
  var %z = $hget(cgsb,buffer), %p = $hget(cgsb,$+($cgsbsock,.prefix))
  var %t = $gettok($hget(cgsb,$+($cgsbsock,.colors)),2,32), %u = $gettok($hget(cgsb,$+($cgsbsock,.colors)),2,32)
  var %a = $hget($cgsbsock,access)
  tokenize 32 %z
  if ($2 == privmsg && $left($3,1) == $chr(35) && $+(:,%p,*) iswm $4) {
    if ($+(:,%p,dns) == $4) {
      if (%a < $getcom(dns)) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ You do not posses enough access for this command. $chr(3) | return }
      elseif (!$5) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ No ip/host/nick specified. $chr(3) }
      else {
        hadd -m $cgsbsock dnsnick $gettok($mid($1,2,$len($1)),1,33)
        hadd -m $cgsbsock dnschannel $3
        var %ni = $+($cgsbsock,.,$hget(cgsb,$+($cgsbsock,.network)),.,$3,.nicks)
        var %k = $remove($strip($5),~,&,@,%,+)
        var %f = $iif($hget(%ni,%k),$gettok($hget($cgsbsock,$+(%k,.host)),2,64),$strip($5))
        botdns $cgsbsock %k %f
      }
      sockwrite -n $cgsbsock silence $+(+,$gettok($mid($1,2,$len($1)),1,33))
      .timer -o 1 2 sockwrite -n $cgsbsock silence $+(-,$gettok($mid($1,2,$len($1)),1,33))
    }
  }
}
on *:sockopen:dns.*:{
  var %t = $gettok($hget(cgsb,$+($gettok($sock($sockname).mark,1,32),.colors)),1,32), %u = $gettok($hget(cgsb,$+($gettok($sock($sockname).mark,1,32),.colors)),2,32)
  if ($sockerr > 0) {
    sockwrite -n $gettok($sock($sockname).mark,1,32) notice $hget($gettok($sock($sockname).mark,1,32),dnsnick) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ Socket error(s). Try again later. $chr(3)
    return
  }
  if ($remove($gettok($sock($sockname).mark,2,32),.) isnum) { sockwrite -n $sockname GET $+(http://cgibin.erols.com/ziring/cgi-bin/nsgate/gate.pl?submit=Search+by+IP+Address&q=,$gettok($sock($sockname).mark,3,32),&mode=2&qtype=PTR&.cgifields=persist&.cgifields=log) HTTP/1.1 }
  else { sockwrite -n $sockname GET $+(http://cgibin.erols.com/ziring/cgi-bin/nsgate/gate.pl?submit=Search+by+Name&mode=1&q=,$gettok($sock($sockname).mark,3,32),&qtype=A&.cgifields=persist&.cgifields=log) HTTP/1.1 }
  sockwrite -n $sockname Host: $+(cgibin.erols.com,$str($crlf, 2))
}
on *:sockread:dns.*:{
  var %t = $gettok($hget(cgsb,$+($gettok($sock($sockname).mark,1,32),.colors)),1,32), %u = $gettok($hget(cgsb,$+($gettok($sock($sockname).mark,1,32),.colors)),2,32)
  if ($sockerr > 0) { sockwrite -n $gettok($sock($sockname).mark,1,32) notice $hget($gettok($sock($sockname).mark,1,32),dnsnick) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ Socket error(s). Try again later. $chr(3) | return }
  var %a, %h, %i
  sockread %a
  %a = $mid(%a,1,600)
  tokenize 32 %a
  if (*<td><font size="+1"><b> &nbsp;* iswm $1-) { hadd $gettok($sock($sockname).mark,1,32) dnsfound $addtok($hget($hget($gettok($sock($sockname).mark,1,32),dnsfound)),$remove($3,&nbsp;),32) }
  .timerenddns -o 1 1 enddns $gettok($sock($sockname).mark,1-2,32)
}
