;TITLE KICKS
;AUTHOR entropy
;COMMANDS setkick(3) setkicks(3) kicks(3) unsetkicks(3) unsetkick(3) badtokens(3) rules(2) unsetrules(2)
;VERSION: 3.0
;HELP setkick [kick] [warning] [banseconds]|Sets specified channel kick to warning and banseconds.|sop
;HELP setkicks [warning] [banseconds]|Sets all channel kicks to warning and banseconds. Available kicks: flood,clones,repeat,spam,swears,punctuation,longtext,caps,codes,channel,badchannels,drones,lame,lock,sticky,rdoor,proxy,version|sop
;HELP kicks|Lists all active channel kicks.|sop
;HELP unsetkicks|Un-Sets all channel kicks.|sop
;HELP unsetkick [kick]|Un-Sets specified channel kick.|sop
;HELP badtokens [tokens]|Sets specified channel bad tokens, or tokens for bad channels kick.|sop
;HELP rules [rules]|Returns active rules for channel, or sets the rules.|none
;HELP unsetrules|Unsets channel rules.|aop

;============================== ALIASES
alias -l sticky { var %re = /(.)\1{7,}/ | if ($regex($1-,%re)) { return $regml(1) } }
alias -l xdrone { 
  var %nick = $gettok($1,1,33)
  var %ident = $gettok($gettok($1,2,33),1,64), %drone
  var %re = /^((?=([^!]*[A-Z]){2})[a-zA-Z]+!~(?=([^@]*[A-Z]){2})[a-zA-Z]+)@(\d+\.){3}\d+$/
  if ($regex($1,%re)) { %drone = y }
  elseif ((*!~*@* iswm $1 && !$regex(%nick,/\w+[\|431aeiou]+/i) && !$regex(%nick,[\[\]\|\\^-_]) && !$regex(%ident,/\w+[\|431aeiou]+/i) && !$regex(%ident,[\[\]\|\\^-_]))) { %drone = y }
  elseif ($right(%ident,1) isnum && ~* iswm %ident && $len(%ident) == 4 && $remove(%ident,~,$right(%ident,1)) isalpha) { %drone = y }
  elseif ($right(%nick,1) isnum && ~ isin %ident && $wildtok(%nick,$+($remove(%ident,~),*),1,32)) { %drone = y }
  elseif ($right(%ident,1) isnum && ~ isin %ident && $mid(%ident,1,-1) isalpha && $len(%nick) == 4) { %drone = y }
  if (%drone == y) { return $true }
}

alias -l ismode {
  ;$1=sockname,$2=mode,$3=channel
  if ($2 isin $hget($+($1,.,$hget(cgsb,$+($1,.network)),.,$3,.nicks),$hget(cgsb,$+($1,.nick)))) { return $true }
}
alias -l compressedtime {
  return $remove($replace($duration($1),wks,w,wk,w,days,d,day,d,hrs,h,hr,h,mins,m,min,m,secs,s,sec,s),$chr(32))
}
alias -l isothermode {
  ;$1=sockname,$2=mode,$3=channel,$4=nick
  if ($2 isin $hget($+($1,.,$hget(cgsb,$+($1,.network)),.,$3,.nicks),$4)) { return $true }
}
alias -l warn {
  var %a = $iif($isadmin($3,$1),5,$iif($getaccess($3,$2,$1),$ifmatch,0)), %h = 0
  if ($isexempt($3,$2,$1) || $isothermode($3,@,$2,$gettok($1,1,33)) || $isothermode($3,&,$2,$gettok($1,1,33)) || $isothermode($3,%,$2,$gettok($1,1,33)) || $isothermode($3,~,$2,$gettok($1,1,33)) || %a > 1) { return }
  else {
    var %warn = $gettok($hget($3,$+($hget(cgsb,$+($3,.network)),.,$2,.,$4)),1,32)
    var %time = $gettok($hget($3,$+($hget(cgsb,$+($3,.network)),.,$2,.,$4)),2,32)
    hinc $3 $+($1,.,$2,.,$4,.warnings)
    if ( $hget($3,$+($1,.,$2,.,$4,.warnings)) > %warn) {
      if ($4 == clones) {
        sockwrite -n $3 mode $2 +b $+(*!*@,$gettok($1,2,64))
        var %f = 1
        while ($gettok($hget($+($hget($3,network),.,$2,.clones),$gettok($1,2,64)),%f,32)) { inc %h | sockwrite -n $3 kick $2 $ifmatch :No clones. $iif(%warn > 0,You have been been warned %warn $iif(%warn == 1,time,times) about this.) $iif(%time != 0,$compressedtime(%time)) ban. | inc %f }
      }
      else {
        sockwrite -n $3 mode $2 +b $mask($1,$hget(cgsb,$+($3,.masks)))
        sockwrite -n $3 kick $2 $gettok($1,1,33) :No $+($5-,.) $iif(%warn > 0,You have been been warned %warn $iif(%warn == 1,time,times) about this.) $iif(%time != 0,$compressedtime(%time)) ban.
      }
      if (%time != 0) { $+(.timer,$3,$2,$iif($4 == clones,$+(*!*@,$gettok($1,2,64)),$mask($1,$hget(cgsb,$+($3,.masks))))) -o 1 %time sockwrite -n $3 mode $2 -b $iif($4 == clones,$+(*!*@,$gettok($1,2,64)),$mask($1,$hget(cgsb,$+($3,.masks)))) }
      hdel $3 $+($hget(cgsb,$+($3,.network)),.,$2,.,$4,.warnings)
    }
    else { sockwrite -n $3 notice $gettok($1,1,33) :No $+($5-,.) This is your $ord($hget($3,$+($1,.,$2,.,$4,.warnings))) $iif($hget($3,$+($1,.,$2,.,$4,.warnings)) == %warn,and final) warning. }
  }
}

alias -l swears {
  var %a = 1, %b = fuck shit cock pussy cunt slut bitch whore nigger fag asshole wtf stfu lmfao, %c = 0
  while ($gettok(%b,%a,32)) {
    if ($+(*,$ifmatch,*) iswm $1-) { inc %c $wildtok($1-,$+(*,$gettok(%b,%a,32),*),0,32) }
    inc %a
  }
  return %c
}
alias -l getswear {
  var %a = 1, %b = fuck shit cock pussy cunt slut bitch whore nigger fag asshole wtf stfu lmfao, %c = 0
  while ($gettok(%b,%a,32)) {
    if ($+(*,$ifmatch,*) iswm $1-) { return $gettok(%b,%a,32) }
    inc %a
  }
}
alias -l acronyms {
  var %a = 1, %b = lol brb bbl bbs np imo imho bbiab bbiaf atm g2g gtg lmao rotflmao rofl wtf stfu lmfao ltns pos, %c = 0
  while ($gettok(%b,%a,32)) {
    if ($+(*,$ifmatch,*) iswm $1-) { inc %c $wildtok($1-,$+(*,$gettok(%b,%a,32),*),0,32) }
    inc %a
  }
  return %c
}
alias -l codes {
  var %a = 1, %b = $chr(2) $chr(3) $chr(15) $chr(22) $chr(31), %c = 0
  while ($gettok(%b,%a,32)) {
    if ($+(*,$ifmatch,*) iswm $1-) { inc %c $wildtok($1-,$+(*,$gettok(%b,%a,32),*),0,32) }
    inc %a
  }
  return %c
}
alias -l smiles {
  var %a = 1, %b = $+(:,$chr(123)) $+(:,$chr(125)) :b :P ;P ;b :D ;D =b =P =D =] :) ;) ;/ :/ ;\ :\ :( ;( :] :[ :< ;< :> =) =] =( =[ => =<, %c = 0
  while ($gettok(%b,%a,32)) {
    if ($+(*,$ifmatch,*) iswm $1-) { inc %c $wildtok($1-,$+(*,$gettok(%b,%a,32),*),0,32) }
    inc %a
  }
  return %c
}

alias capsMS { return $calc($regex($remove($1-,$chr(32)),/[A-Z]/g) / $len($remove($1-,$chr(32))) * 100) }

alias -l kicks {
  var %t = $gettok($hget(cgsb,$+($,.colors)),1,32), %u = $gettok($hget(cgsb,$+($1,.colors)),2,32)
  hadd $1 $+($hget(cgsb,$+($1,.network)),.,$3,.flood) 4 2
  hadd $1 $+($hget(cgsb,$+($1,.network)),.,$3,.flooding) $4-5
  hadd $1 $+($hget(cgsb,$+($1,.network)),.,$3,.clones) $4-5
  hadd $1 $+($hget(cgsb,$+($1,.network)),.,$3,.repeat) $4-5
  hadd $1 $+($hget(cgsb,$+($1,.network)),.,$3,.spam) $4-5
  hadd $1 $+($hget(cgsb,$+($1,.network)),.,$3,.swears) $4-5
  hadd $1 $+($hget(cgsb,$+($1,.network)),.,$3,.punctuation) $4-5
  hadd $1 $+($hget(cgsb,$+($1,.network)),.,$3,.longtext) $4-5
  hadd $1 $+($hget(cgsb,$+($1,.network)),.,$3,.caps) $4-5
  hadd $1 $+($hget(cgsb,$+($1,.network)),.,$3,.codes) $4-5
  hadd $1 $+($hget(cgsb,$+($1,.network)),.,$3,.channel) $4-5
  hadd $1 $+($hget(cgsb,$+($1,.network)),.,$3,.badchannels) $ctime
  hadd $1 $+($hget(cgsb,$+($1,.network)),.,$3,.drones) $ctime
  hadd $1 $+($hget(cgsb,$+($1,.network)),.,$3,.lame) $ctime
  hadd $1 $+($hget(cgsb,$+($1,.network)),.,$3,.lock) 7 3
  hadd $1 $+($hget(cgsb,$+($1,.network)),.,$3,.sticky) $4-5
  hadd $1 $+($hget(cgsb,$+($1,.network)),.,$3,.rdoor) $ctime
  hadd $1 $+($hget(cgsb,$+($1,.network)),.,$3,.proxy) $ctime
  hadd $1 $+($hget(cgsb,$+($1,.network)),.,$3,.version) $ctime
  sockwrite -n $1 notice $2 $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u))) $+ All kicks have been set to: $+($chr(2),$4,$chr(2)) $+($iif($4 == 1,warning,warnings),$chr(44)) $+($chr(2),$compressedtime($5),$chr(2)) ban time. $chr(3)
}
alias -l unsetkicks {
  var %t = $gettok($hget(cgsb,$+($1,.colors)),1,32), %u = $gettok($hget(cgsb,$+($1,.colors)),2,32)
  hdel $1 $+($hget(cgsb,$+($1,.network)),.,$3,.flood)
  hdel $1 $+($hget(cgsb,$+($1,.network)),.,$3,.flooding)
  hdel $1 $+($hget(cgsb,$+($1,.network)),.,$3,.clones)
  hdel $1 $+($hget(cgsb,$+($1,.network)),.,$3,.repeat)
  hdel $1 $+($hget(cgsb,$+($1,.network)),.,$3,.spam)
  hdel $1 $+($hget(cgsb,$+($1,.network)),.,$3,.swears)
  hdel $1 $+($hget(cgsb,$+($1,.network)),.,$3,.punctuation)
  hdel $1 $+($hget(cgsb,$+($1,.network)),.,$3,.longtext)
  hdel $1 $+($hget(cgsb,$+($1,.network)),.,$3,.caps)
  hdel $1 $+($hget(cgsb,$+($1,.network)),.,$3,.codes)
  hdel $1 $+($hget(cgsb,$+($1,.network)),.,$3,.channel)
  hdel $1 $+($hget(cgsb,$+($1,.network)),.,$3,.badchannels)
  hdel $1 $+($hget(cgsb,$+($1,.network)),.,$3,.badtokens)
  hdel $1 $+($hget(cgsb,$+($1,.network)),.,$3,.drones)
  hdel $1 $+($hget(cgsb,$+($1,.network)),.,$3,.lame)
  hdel $1 $+($hget(cgsb,$+($1,.network)),.,$3,.lock)
  hdel $1 $+($hget(cgsb,$+($1,.network)),.,$3,.sticky)
  hdel $1 $+($hget(cgsb,$+($1,.network)),.,$3,.rdoor)
  hdel $1 $+($hget(cgsb,$+($1,.network)),.,$3,.proxy)
  hdel $1 $+($hget(cgsb,$+($1,.network)),.,$3,.version)
  sockwrite -n $1 notice $2 $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u))) $+ All kicks have been unset. $chr(3)
}
alias -l checklock {
  if ($hget($1,$+($2,.locked))) {
    hdel $1 $+($2,.locked)
    sockwrite -n $1 mode $2 $+(-,$3)
    sockwrite -n $1 notice $2 :Channel is now unlocked. We appologize for any inconvenience this may have caused.
  }
}
alias isinmode {
  sockwrite -n $1 mode $2 $+(+,$3)
  sockwrite -n $1 notice $2 :Channel temporarily locked for 30 secs due to flooding.
}
alias -l lock {
  isinmode $1 $remove($2,:) miMRr
  .timer $+ $1 $+ $remove($2,:) $+ unlock -o 1 30 checklock $1 $remove($2,:) miMRr
}
alias -l isexempt {
  ;$1=socket,$2=channel,$3=host
  var %a = 1, %b
  while ($hget($+($1,.,$hget(cgsb,$+($1,.network)),.,$2,.exempts),%a).item) {
    %b = $ifmatch
    if (%b iswm $3) { return $true }
    inc %a
  }
}
alias -l cgsbsock { return $hget(cgsb,socket) | halt }
alias -l doversion {
  sockwrite -n $1 privmsg $gettok($2,1,33) :VERSION
  .timerban $+ $3 -o 1 1 rem $1-
}
alias -l rem {
  sockwrite -n $1 mode $3 +b $mask($2,$hget(cgsb,$+($cgsbsock,.masks)))
  sockwrite -n $1 kick $3 $gettok($2,1,33) :Banned: No version, no channel access.
}
;============================== EVENTS
on *:signal:kicks:{
  var %z = $hget(cgsb,buffer), %p = $hget(cgsb,$+($cgsbsock,.prefix))
  var %t = $gettok($hget(cgsb,$+($cgsbsock,.colors)),1,32), %u = $gettok($hget(cgsb,$+($cgsbsock,.colors)),2,32)
  var %a = $hget($cgsbsock,access), %m = $hget($+($cgsbsock,.,$hget(cgsb,$+($cgsbsock,.network)),.,$remove($3,:),.nicks),$gettok($mid($1,2,$len($1)),1,33))
  tokenize 32 %z
  var %g = $hget(cgsb,$+($cgsbsock,.network))
  %g = $gettok($hget($cgsbsock,$+(%g,.,$remove($3,:),.lock)),2,32)
  if (%a > 1 || @ isin %m || ~ isin %m) { goto endcrap }

  if ($left($remove($3,:),1) == $chr(35)) {
    hinc $+(-mu,%g) $cgsbsock $+($remove($3,:),.lock)
  }
  var %g = $hget(cgsb,$+($cgsbsock,.network))
  %g = $gettok($hget($cgsbsock,$+(%g,.,$remove($3,:),.lock)),1,32)

  if (!$hget($cgsbsock,$+($remove($3,:),.locked)) && !$hget($+($cgsbsock,.,$remove($3,:),.netsplit)) && $hget($cgsbsock,$+($remove($3,:),.lock)) >= 7 && $ismode($cgsbsock,@,$remove($3,:)) && $hget($cgsbsock,$+($hget(cgsb,$+($cgsbsock,.network)),.,$remove($3,:),.lock))) {
    hadd $cgsbsock $+($remove($3,:),.locked) $ctime
    lock $cgsbsock $remove($3,:)
    return
  }
  elseif ($2 == join) {
    var %clones = 3
    if ($hget($+($cgsbsock,.,$remove($3,:),.netsplit))) { hdel $+($cgsbsock,.,$remove($3,:),.netsplit) $gettok($mid($1,2,$len($1)),1,33) }
    if (!$hget($+($cgsbsock,.,$remove($3,:),.netsplit),1).item && $hget($+($cgsbsock,.,$remove($3,:),.netsplit))) { hfree $+($cgsbsock,.,$remove($3,:),.netsplit) | return }
    if ($gettok($mid($1,2,$len($1)),1,33) != $hget(cgsb,$+($cgsbsock,.nick))) { sockwrite -n $cgsbsock whois $gettok($mid($1,2,$len($1)),1,33) }
    if (%a <= 1 && $numtok($hget($+($cgsbsock,.,$hget(cgsb,$+($cgsbsock,.network)),.,$remove($3,:),.clones),$gettok($mid($1,2,$len($1)),2,64)),32) > %clones && $gettok($hget($cgsbsock, $+($hget(cgsb,$+($cgsbsock,.network)),.,$remove($3,:),.clones) ),1,32) isnum) {
      warn $mid($1,2,$len($1)) $remove($3,:) $cgsbsock clones excessive cloning
    }
    elseif (%a <= 1 && $ismode($cgsbsock,@,$remove($3,:)) && $xdrone($mid($1,2,$len($1))) && $hget($cgsbsock,$+($hget(cgsb,$+($cgsbsock,.network)),.,$remove($3,:),.drones))) {
      var %x = 1, %y = $hget($cgsbsock,$+($hget(cgsb,$+($cgsbsock,.network)),.,$remove($3,:),.drones)), %z, %found = 0
      while ($gettok(%y,%x,32)) { %z = $ifmatch | if (%z iswm $mid($1,2,$len($1))) { inc %found | break } | inc %x }
      if (%found == 0) {
        sockwrite -n $cgsbsock mode $remove($3,:) +bb $+($gettok($mid($1,2,$len($1)),1,33),!*@*) $+(*!,$gettok($gettok($mid($1,2,$len($1)),2,33),1,64),@*)
        sockwrite -n $cgsbsock kick $remove($3,:) $gettok($mid($1,2,$len($1)),1,33) :Drone or suspicious nick/ident.
        $+(.timer,$cgsbsock,$remove($3,:),$+($gettok($mid($1,2,$len($1)),1,33),!*@*),.,$+(*!,$gettok($gettok($mid($1,2,$len($1)),2,33),1,64),@*)) -o 1 600 sockwrite -n $cgsbsock mode $remove($3,:) -bb $+($gettok($mid($1,2,$len($1)),1,33),!*@*) $+(*!,$gettok($gettok($mid($1,2,$len($1)),2,33),1,64),@*)
      }
    }
    elseif (%a <= 1 && $ismode($cgsbsock,@,$remove($3,:)) && $swears($mid($1,2,$len($1))) && $hget($cgsbsock,$+($hget(cgsb,$+($cgsbsock,.network)),.,$remove($3,:),.lame))) {
      var %mask = $iif($getswear($gettok($mid($1,2,$len($1)),1,33)),$+(*,$ifmatch,*!*@*),$iif($getswear($gettok($gettok($mid($1,2,$len($1)),2,33),1,64)),$+(*!*,$ifmatch,*@*),$+(*!*@*,$getswear($gettok($mid($1,2,$len($1)),2,64)),*)))
      var %option = $iif($getswear($gettok($mid($1,2,$len($1)),1,33)),nick,$iif($getswear($gettok($gettok($mid($1,2,$len($1)),2,33),1,64)),ident,host))
      sockwrite -n $cgsbsock mode $remove($3,:) +b %mask
      sockwrite -n $cgsbsock kick $remove($3,:) $gettok($mid($1,2,$len($1)),1,33) :Lame %option detected. Change this and you may return.
      $+(.timer,$cgsbsock,$remove($3,:),%mask) -o 1 600 sockwrite -n $cgsbsock mode $remove($3,:) -b %mask
    }
    var %z = 1, %b = flood clones repeat spam swears punctuation longtext caps codes channel badchannels drones lame lock sticky rdoor, %c, %d, %e
    while ($gettok(%b,%z,32)) {
      %c = $ifmatch
      if ($hget($cgsbsock,$+($hget(cgsb,$+($cgsbsock,.network)),.,$remove($3,:),.,%c))) { %e = $iif(%c == lock,flood,%c) | %d = $iif($istok(%d,%e,32),%d,$addtok(%d,%e,44)) }
      inc %z
    }
    if (%a <= 1 && $hget($cgsbsock,$+($hget(cgsb,$+($cgsbsock,.network)),.,$remove($3,:),.proxy)) && $gettok($mid($1,2,$len($1)),1,33) != $hget(cgsb,$+($cgsbsock,.nick))) { proxy $gettok($mid($1,2,$len($1)),2,64) $cgsbsock $remove($3,:) $mid($1,2,$len($1)) }
    if (%a <= 1 && $hget($cgsbsock,$+($remove($3,:),.rules)) && $gettok($mid($1,2,$len($1)),1,33) != $hget(cgsb,$+($cgsbsock,.nick))) { $+(.timer,$cgsbsock,$remove($3,:),rules) -o 1 1 sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ Type $+(,$hget(cgsb,$+($cgsbsock,.prefix)),rules) for the $remove($3,:) channel rules. $chr(3) }
    if (%a <= 1 && $hget($cgsbsock,$+($hget(cgsb,$+($cgsbsock,.network)),.,$remove($3,:),.version)) && $gettok($mid($1,2,$len($1)),1,33) != $hget(cgsb,$+($cgsbsock,.nick))) { hadd $cgsbsock versionchan $remove($3,:) | .timerversion $+ $remove($3,:) -om 1 100 doversion $cgsbsock $mid($1,2,$len($1)) $remove($3,:) }
    hadd -z $cgsbsock $+($remove($3,:),.rdoor.,$mid($1,2,$len($1))) 5
  }
  if ($2 == 319) {
    var %a = 1, %b = $hget(cgsb,$+($cgsbsock,.channels)), %c, %d, %y = $mid($5-,2,$len($5-))
    while ($gettok(%b,%a,32)) {
      %c = $remove($ifmatch,@,+,&,%,~)
      if ($ismode($cgsbsock,@,%c) && $hget($cgsbsock,$+($hget(cgsb,$+($cgsbsock,.network)),.,%c,.badchannels)) || $ismode($cgsbsock,~,%c) && $hget($cgsbsock,$+($hget(cgsb,$+($cgsbsock,.network)),.,%c,.badchannels)) || $ismode($cgsbsock,&,%c) && $hget($cgsbsock,$+($hget(cgsb,$+($cgsbsock,.network)),.,%c,.badchannels))) {
        var %e = 1, %f, %g, %z
        %f = $hget($cgsbsock,$+($hget(cgsb,$+($cgsbsock,.network)),.,%c,.badtokens))
        while ($gettok(%f,%e,32)) {
          %g = $ifmatch
          if ($wildtok(%y,$+(*,%g,*),1,32)) { %z = $addtok(%z,$wildtok(%y,$+(*,%g,*),1,32),32) }
          inc %e
        }
        if (%z) { sockwrite -n $cgsbsock kick %c $4 :You are on $+(%z,.) $iif($numtok(%z,32) == 1,Leave this channel,Leave these channels) and you may return. }
      }
      inc %a
    }
  }
  if ($2 == part) {
    var %a = $hget($cgsbsock,access)
    if (%a <= 1 && $ismode($cgsbsock,@,$3) && $hget($cgsbsock,$+($3,.rdoor.,$mid($1,2,$len($1)))) && $hget($cgsbsock,$+($hget(cgsb,$+($cgsbsock,.network)),.,$remove($3,:),.rdoor))) {
      sockwrite -n $cgsbsock mode $3 +b $mask($mid($1,2,$len($1)),$hget(cgsb,$+($cgsbsock,.masks)))
      $+(.timer,$cgsbsock,$3,$mask($mid($1,2,$len($1)),$hget(cgsb,$+($cgsbsock,.masks)))) -o 1 600 sockwrite -n $cgsbsock mode $3 -b $mask($mid($1,2,$len($1)),$hget(cgsb,$+($cgsbsock,.masks)))
    }
  }
  if ($2 == quit) {
    var %a = 1, %b = $hget(cgsb,$+($cgsbsock,.channels)), %acc = $hget($cgsbsock,access), %c, %d
    while ($gettok(%b,%a,32)) {
      %c = $mid($ifmatch,$pos($ifmatch,$chr(35)),$len($ifmatch))
      %d = $hget($+($cgsbsock,.,$hget(cgsb,$+($cgsbsock,.network)),.,%c,.nicks),$gettok($mid($1,2,$len($1)),1,33))

      if ((:*.net *.split === $3-) || (:*.*.* *.*.* iswm $3- && $3 != :Quit:)) { hadd -m $+($cgsbsock,.,%c,.netsplit) $gettok($mid($1,2,$len($1)),1,33) $ctime }

      if (%d && $ismode($cgsbsock,@,%c) && %acc <= 1 && $hget($cgsbsock,$+(%c,.rdoor.,$mid($1,2,$len($1)))) && $hget($cgsbsock,$+(%c,.rdoor.,$mid($1,2,$len($1))))) {
        sockwrite -n $cgsbsock mode %c +b $mask($mid($1,2,$len($1)),$hget(cgsb,$+($cgsbsock,.masks)))
        $+(.timer,$cgsbsock,%c,$mask($mid($1,2,$len($1)),$hget(cgsb,$+($cgsbsock,.masks)))) -o 1 600 sockwrite -n $cgsbsock mode %c -b $mask($mid($1,2,$len($1)),$hget(cgsb,$+($cgsbsock,.masks)))
      }
      inc %a
    }
  }
  if ($2 == nick) {
    var %a = 1, %b = $hget(cgsb,$+($cgsbsock,.channels)), %c, %acc = $hget($cgsbsock,access)
    while ($gettok(%b,%a,32)) {
      %c = $mid($ifmatch,$pos($ifmatch,$chr(35)),$len($ifmatch))
      var %m = $hget($+($cgsbsock,.,$hget(cgsb,$+($cgsbsock,.network)),.,%c,.nicks),$remove($3,:))
      var %bot = $hget($+($cgsbsock,.,$hget(cgsb,$+($cgsbsock,.network)),.,%c,.nicks),$hget(cgsb,$+($cgsbsock,.nick)))
      if (%m && $swears($remove($3,:)) && %acc <= 1 && @ isin %bot && $hget($cgsbsock,$+($hget(cgsb,$+($cgsbsock,.network)),.,%c,.lame))) {
        sockwrite -n $cgsbsock mode %c +b $+(*,$getswear($remove($3,:)),*!*@*)
        sockwrite -n $cgsbsock kick %c $remove($3,:) :Lame nickname detected.
        $+(.timer,$cgsbsock,$remove($3,:),$+(*,$getswear($remove($3,:)),*!*@*)) -o 1 600 sockwrite -n $cgsbsock mode $remove($3,:) -b $+(*,$getswear($remove($3,:)),*!*@*)
      }
      inc %a
    }
  }
  if ($2 == notice) {
    var %a = $hget($cgsbsock,access)
    if ($left($3,1) == $chr(35) && $gettok($mid(1,2,$len($1)),1,33) != ChanServ) {
      if (%a <= 1 && $gettok($hget($cgsbsock,$+($hget(cgsb,$+($cgsbsock,.network)),.,$remove($3,:),.channel)),1,32) isnum) {
        warn $mid($1,2,$len($1)) $3 $cgsbsock channel using an all channel event
      }
    }
    elseif (:VERSION == $4 && $hget($sockname,versionchan)) {
      .timerban $+ $hget($cgsbsock,versionchan) off
      hdel $cgsbsock versionchan
    }
  }
  if ($2 == mode && $left($3,1) == $chr(35)) {
    if ($left($4,1) == - && m isin $4 && i isin $4 && r isin $4 && $hget($cgsbsock,$+($3,.locked))) { hdel $cgsbsock $+($3,.locked) }
  }
  if ($2 == privmsg && $left($3,1) == $chr(35)) {
    var %gx = $hget(cgsb,$+($cgsbsock,.network)), %g = $gettok($hget($cgsbsock,$+($hget(cgsb,$+($cgsbsock,.network)),.,$3,.flood)),2,32), %g2 = $gettok($hget($cgsbsock,$+($hget(cgsb,$+($cgsbsock,.network)),.,$3,.flood)),1,32)
    hinc $+(-mu,%g) $cgsbsock $+($3,.,$gettok($mid($1,2,$len($1)),2,64),.flood) 1
    if ($hget($cgsbsock,$+($3,.,$gettok($mid($1,2,$len($1)),2,64),.flood)) > %g2 && $gettok($hget($cgsbsock,$+($hget(cgsb,$+($cgsbsock,.network)),.,$remove($3,:),.flooding)),1,32) isnum) {
      warn $mid($1,2,$len($1)) $3 $cgsbsock flooding flooding
      sockwrite -n $cgsbsock silence $+(+,$gettok($mid($1,2,$len($1)),1,33))
      .timer -o 1 5 sockwrite -n $cgsbsock silence $+(-,$gettok($mid($1,2,$len($1)),1,33))
      goto endcrap
    }

    if (:* iswm $4- && $4 != :ACTION) {
      if ($gettok($hget($cgsbsock,$+($hget(cgsb,$+($cgsbsock,.network)),.,$remove($3,:),.channel)),1,32) isnum) {
        warn $mid($1,2,$len($1)) $3 $cgsbsock channel using an all channel event
        goto endcrap
      }
    }

    if ($gettok($hget($cgsbsock,$+($hget(cgsb,$+($cgsbsock,.network)),.,$remove($3,:),.sticky)),1,32) isnum && $sticky($mid($4-,2,$len($4-)))) {
      warn $mid($1,2,$len($1)) $3 $cgsbsock sticky sticky $qt($regml(1)) key
      goto endcrap
    }

    if ($hget($cgsbsock,$+($hget(cgsb,$+($cgsbsock,.network)),.,$3,.,$gettok($mid($1,2,$len($1)),1,33),.last)) == $mid($4-,2,$len($4-))) {
      hinc $cgsbsock $+($3,.repeat) 
      if ($gettok($hget($cgsbsock,$+($hget(cgsb,$+($cgsbsock,.network)),.,$remove($3,:),.repeat)),1,32) isnum) { warn $mid($1,2,$len($1)) $3 $cgsbsock repeat repeating | goto endcrap }
    }

    if (($wildtok($remove($mid($5-,2,$len($5-)),$chr(1)),#*,1,32) && $wildtok($remove($mid($5-,2,$len($5-)),$chr(1)),#*,1,32) != $3 && $gettok($hget($cgsbsock, $+($cgsbsock,.,$hget(cgsb,$+($cgsbsock,.network)),.,$remove($3,:),.spam)),1,32) isnum) || ($wildtok($remove($mid($5-,2,$len($5-)),$chr(1)),www.*,1,32) && $gettok($hget($cgsbsock, $+($cgsbsock,.,$hget(cgsb,$+($cgsbsock,.network)),.,$remove($3,:),.spam)),1,32) isnum) || ($wildtok($remove($mid($5-,2,$len($5-)),$chr(1)),http://*,1,32) && $gettok($hget($cgsbsock, $+($cgsbsock,.,$hget(cgsb,$+($cgsbsock,.network)),.,$remove($3,:),.spam)),1,32) isnum)) {
      hinc $cgsbsock $+($3,.spam)
      if ($gettok($hget($cgsbsock,$+($hget(cgsb,$+($cgsbsock,.network)),.,$remove($3,:),.flood)),1,32) isnum) { warn $mid($1,2,$len($1)) $3 $cgsbsock spam spamming | goto endcrap }
    }

    if ($swears($remove($mid($4-,2,$len($4-)),$chr(1))) > 0 && $gettok($hget($cgsbsock,$+($hget(cgsb,$+($cgsbsock,.network)),.,$remove($3,:),.swears)),1,32) isnum) {
      warn $mid($1,2,$len($1)) $3 $cgsbsock swears swearing
      goto endcrap
    }
    if ((!!! isin $mid($4-,2,$len($4-)) && $gettok($hget($cgsbsock,$+($hget(cgsb,$+($cgsbsock,.network)),.,$remove($3,:),.punctuation)),1,32) isnum) || (??? isin $mid($4-,2,$len($4-)) && $gettok($hget($cgsbsock,$+($hget(cgsb,$+($cgsbsock,.network)),.,$remove($3,:),.punctuation)),1,32) isnum)) {
      warn $mid($1,2,$len($1)) $3 $cgsbsock punctuation using excessive punctuation
      goto endcrap
    }
    if ($len($remove($mid($4-,2,$len($4-)),$chr(1))) >= 430 && $gettok($hget($cgsbsock,$+($hget(cgsb,$+($cgsbsock,.network)),.,$remove($3,:),.longtext)),1,32) isnum) {
      warn $mid($1,2,$len($1)) $3 $cgsbsock longtext using long text
      goto endcrap
    }
    if ($capsMS($mid($4-,2,$len($4-))) > 50 && $len($remove($4-,:)) > 30 && $gettok($hget($cgsbsock,$+($hget(cgsb,$+($cgsbsock,.network)),.,$remove($3,:),.caps)),1,32) isnum) {
      warn $mid($1,2,$len($1)) $3 $cgsbsock caps using more than 50% caps per line. $+($round($capsMS($mid($4-,2,$len($4-))),2),%) used
      goto endcrap
    }
    if ($calc($codes($remove($mid($4-,2,$len($4-)),$chr(1))) / $len($remove($mid($4-,2,$len($4-)),$chr(1))) * 100) >= 30 && $len($remove($mid($4-,2,$len($4-)),$chr(1))) > 30 && $gettok($hget($cgsbsock,$+($hget(cgsb,$+($cgsbsock,.network)),.,$remove($3,:),.codes)),1,32) isnum) {
      warn $mid($1,2,$len($1)) $3 $cgsbsock codes using more than 30% control codes per line. $+($round($calc($codes($remove($mid($4-,2,$len($4-)),$chr(1))) / $len($remove($mid($4-,2,$len($4-)),$chr(1))) * 100),2),%) used
      goto endcrap
    }
    :endcrap
    var %t = $gettok($hget(cgsb,$+($cgsbsock,.colors)),1,32), %u = $gettok($hget(cgsb,$+($cgsbsock,.colors)),2,32)
    if ($+(:,%p,badtokens) == $4) {
      if (%a <= $getcom(badtokens)) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ You do not posses enough access for this command. }
      elseif (!$5) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ Invalid syntax. Syntax: $+(,$hget(cgsb,$+($cgsbsock,.prefix)),badtokens) [token1] [token2]. }
      else { 
        hadd $cgsbsock $+($hget(cgsb,$+($cgsbsock,.network)),.,$3,.badtokens) $5-
        sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33)) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ Badtokens are now $+(,$5-,)
        return
      }
      return
    }
    elseif ($+(:,%p,setkicks) == $4) {
      if (%a < $getcom(setkicks)) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ You do not posses enough access for this command. $chr(3) | return }
      elseif (!$5-6) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ Invalid syntax. Syntax: $+(,%p,setkicks) [warnings] [banseconds]. $chr(3) }
      else { kicks $cgsbsock $gettok($mid($1,2,$len($1)),1,33) $3 $5- }
      return
    }
    elseif ($+(:,%p,setkick) == $4) {
      if (%a < $getcom(setkick)) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ You do not posses enough access for this command. $chr(3) | return }
      elseif ($istok(clones repeat spam swears punctuation longtext caps codes channel drones sticky,$5,32)) {
        if (!$6 && $6 != 0) {
          sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ No warnings and ban seconds specified! $chr(3)
          return
        }
        hadd $cgsbsock $+($hget(cgsb,$+($cgsbsock,.network)),.,$3,.,$5) $iif($5 == drones || $5 == lame || $5 == lock || $5 == rdoor || $5 == proxy,$iif($6,$6-,$ctime),$6-7)
        sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ $iif($5 == drones || $5 == lame || $5 == lock || $5 == rdoor || $5 == proxy,$+($chr(2),$5,$chr(2)) kick enabled. $iif($6 && $5 == drones,Exempting: $+($chr(2),$6-,$chr(2))),$+($chr(2),$5,$chr(2)) setting set to: $+($chr(2),$6,$chr(2)) $+($iif($6 == 1,warning,warnings),$chr(44)) $+($chr(2),$compressedtime($7),$chr(2)) ban time.) $chr(3)
      }
      elseif ($istok(lame rdoor proxy version badchannels,$5,32)) {
        hadd $cgsbsock $+($hget(cgsb,$+($cgsbsock,.network)),.,$3,.,$5) $ctime
        sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ $+($chr(2),$5,$chr(2)) kick enabled. $chr(3)
      }
      elseif ($istok(flood lock,$5,32)) {
        if (!$6 && $6 != 0) {
          sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ No $replace($5,lock,joins,flood,lines) and seconds specified! $chr(3)
          return
        }
        hadd $cgsbsock $+($hget(cgsb,$+($cgsbsock,.network)),.,$3,.,$5) $6-
        if ($5 == flood) { hadd $cgsbsock $+($hget(cgsb,$+($cgsbsock,.network)),.,$3,.flooding) 0 60 }
        sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ $+($chr(2),$5,$chr(2)) kick enabled. $+($chr(2),$6,$chr(2)) $iif($5 == lock,join(s),line(s)) in $+($chr(2),$compressedtime($7),$chr(2)) $+ . $chr(3)
      }
      else { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ Invalid kick! Available: proxy flood clones repeat spam swears punctuation longtext caps codes channel badchannels drones lame lock sticky drones rdoor. $chr(3) }
      return
    }
    elseif ($+(:,%p,kicks) == $4) {
      if (%a < $getcom(kicks)) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ You do not posses enough access for this command. $chr(3) | return }
      var %a = 1, %b = proxy flood clones repeat spam swears punctuation longtext caps codes channel badchannels drones lame lock sticky rdoor version, %c, %d
      while ($gettok(%b,%a,32)) {
        %c = $ifmatch
        if ($hget($cgsbsock,$+($hget(cgsb,$+($cgsbsock,.network)),.,$3,.,%c))) { %d = $iif(%c == drones || %c == lame || %c == rdoor || %c == proxy || %c == badchannels || %c == version,$addtok(%d,%c,32),$iif(%c == lock || %c == flood,$addtok(%d,$+(%c,$chr(40),$replace($hget($cgsbsock,$+($hget(cgsb,$+($cgsbsock,.network)),.,$3,.,%c)),$chr(32),:),$chr(41)),32),$addtok(%d,$+(%c,$chr(40),$replace($hget($cgsbsock,$+($hget(cgsb,$+($cgsbsock,.network)),.,$3,.,%c)),$chr(32),$chr(44)),$chr(41)),32))) }
        inc %a
      }
      sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ Active kicks on $+(,$3,:) $iif(%d,$ifmatch,None) $chr(3)
      return
    }
    elseif ($+(:,%p,unsetrules) == $4) {
      if (%a < $getcom(unsetrules)) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ You do not posses enough access for this command. $chr(3) | return }
      elseif (!$hget($cgsbsock,$+($3,.rules))) {
        sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ There are no channel rules set. $chr(3)
        return
      }
      hdel $cgsbsock $+($3,.rules)
      sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ Channel $+(,$3,) rules are now unset. $chr(3)
      return
    }
    elseif ($+(:,%p,rules) == $4) {
      if ($5 && %a < $getcom(rules)) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ You do not posses enough access for this command. $chr(3) | return }
      elseif ($5) {
        sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ Channel $+(,$3,) rules are now: $+(,$5-,.)
        hadd $cgsbsock $+($3,.rules) $5-
        return
      }
      var %a = 1, %b = proxy flood clones repeat spam swears punctuation longtext caps codes channel badchannels drones lame lock sticky rdoor, %c, %d, %e
      while ($gettok(%b,%a,32)) {
        %c = $ifmatch
        if ($hget($cgsbsock,$+($hget(cgsb,$+($cgsbsock,.network)),.,$3,.,%c))) { %e = %c | %d = $iif($istok(%d,%e,32),%d,$addtok(%d,%e,44)) }
        inc %a
      }
      if ($hget($cgsbsock,$+($3,.rules))) { 
        sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ Channel $+(,$3,) Rules: $chr(3)
        sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ $hget($cgsbsock,$+($3,.rules)) $chr(3)
        if (%d) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ active kicks: $replace($reptok($replace(%d,flood,flooding,codes,excessive control codes,badchannels,being on badchannels,clones,excessive clones,punctuation,excessive punctuation,caps,excessive caps,repeat,repeating,lame,lameness,sticky,stickey keys,rdoor,revolving doors),channel,using all channel events,1,44),$chr(44),$+($chr(44),$chr(32))) $+ . $chr(3) }
        if ($hget($cgsbsock,$+($3,.awaydeop))) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ Deop away nicknames without access is On $chr(3) }
        return
      }
      else { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ There are no channel rules to the best of my knowledge. $chr(3) }
      return
    }
    elseif ($+(:,%p,unsetkicks) == $4) { 
      if (%a < $getcom(unsetkicks)) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ You do not posses enough access for this command. $chr(3) | return }
      unsetkicks $cgsbsock $gettok($mid($1,2,$len($1)),1,33) $3
      return
    }
    elseif ($+(:,%p,unsetkick) == $4) { 
      if (%a < $getcom(unsetkick)) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ You do not posses enough access for this command. $chr(3) | return }
      elseif ($istok(proxy flood clones repeat spam swears punctuation longtext caps codes channel badchannels drones lame lock sticky rdoor,$5,32)) {
        hdel $cgsbsock $+($hget(cgsb,$+($cgsbsock,.network)),.,$3,.,$5)
        if ($5 == flood) { hdel $cgsbsock $+($hget(cgsb,$+($cgsbsock,.network)),.,$3,.flooding) }
        sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ Kick $+(,$5,) has been unset. $chr(3)
      }
      else { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ Invalid kick! Available: flood clones repeat spam swears punctuation longtext caps codes channel badchannels drones lame lock sticky. $chr(3) }
      return
    }
    hadd $cgsbsock $+($hget(cgsb,$+($cgsbsock,.network)),.,$3,.,$gettok($mid($1,2,$len($1)),1,33),.last) $mid($4-,2,$len($4-))
  }
}
alias -l proxy {
  var %p = $+(proxy,$r(1,9999))
  sockclose %p
  sockopen %p $1 8080
  sockmark %p $2-

  var %p = $+(proxy,$r(1,9999))
  sockclose %p
  sockopen %p $1 8000
  sockmark %p $2-

  var %p = $+(proxy,$r(1,9999))
  sockclose %p
  sockopen %p $1 3128
  sockmark %p $2-
}
on *:sockopen:proxy*:{
  if ($sockerr) { return }
  var %sock = $gettok($sock($sockname).mark,1,32)
  var %chan = $gettok($sock($sockname).mark,2,32)
  var %nick = $gettok($sock($sockname).mark,3,32)
  if ($isexempt(%sock,%chan,%nick)) { sockclose $sockname | return }
  sockwrite -n %sock mode %chan +b $+(*!*@,$gettok(%nick,2,64))
  sockwrite -n %sock kick %chan $gettok(%nick,1,33) :Banned: No proxies.
  sockclose $sockname
}
