;TITLE LIMIT
;AUTHOR entropy
;COMMANDS limit(2)
;VERSION: 1.1
;HELP limit [N]|Limits channel users to +N. You can unset this if you supply no value.|aop

;============================== ALIASES
alias -l ismode {
  ;$1=sockname,$2=mode,$3=channel
  if ($2 isin $hget($+($1,.,$hget(cgsb,$+($1,.network)),.,$3,.nicks),$hget(cgsb,$+($1,.nick)))) { return $true }
}
alias -l limit {
  var %l = $hget($+($1,.,$hget(cgsb,$+($1,.network)),.,$2,.nicks),0).item, %l2 = $hget($1,$+($2,.limit)), %l3 = $hget($1,$+($2,.max))
  if ($ismode($1,@,$2) && %l2 isnum && $calc(%l + %l2) != %l3) {
    sockwrite -n $1 mode $2 +l $calc(%l + %l2)
  }
}
alias -l cgsbsock { return $hget(cgsb,socket) | halt }
;============================== EVENTS
on *:signal:limit:{
  var %z = $hget(cgsb,buffer), %p = $hget(cgsb,$+($cgsbsock,.prefix))
  var %t = $gettok($hget(cgsb,$+($cgsbsock,.colors)),1,32), %u = $gettok($hget(cgsb,$+($cgsbsock,.colors)),2,32)
  tokenize 32 %z
  var %d = $gettok($mid($1,2,$len($1)),1,33)
  if ($2 == join && %d != $hget(cgsb,$+($cgsbsock,.nick))) {
    if ($hget($cgsbsock,$+($mid($3,2,$len($3)),.limit))) { $+(.timer,$hget(cgsb,$+($cgsbsock,.network)),.,$mid($3,2,$len($3)),.limit) -o 1 60 limit $cgsbsock $mid($3,2,$len($3)) }
  }
  elseif ($2 == part && %d != $hget(cgsb,$+($cgsbsock,.nick))) {
    if ($hget($cgsbsock,$+($3,.limit))) { $+(.timer,$hget(cgsb,$+($cgsbsock,.network)),.,$3,.limit) -o 1 60 limit $cgsbsock $3 }
  }
  elseif ($2 == quit && %d != $hget(cgsb,$+($cgsbsock,.nick))) {
    var %a = 1, %b = $hget(cgsb,$+($cgsbsock,.channels)), %g
    while ($gettok(%b,%a,32)) {
      %g = $mid($ifmatch,$pos($ifmatch,$chr(35)),$len($ifmatch))
      if ($hget($cgsbsock,$+(%g,.limit))) { $+(.timer,$hget(cgsb,$+($cgsbsock,.network)),.,%g,.limit) -o 1 60 limit $cgsbsock %g }
      inc %a
    }
  }
  elseif ($2 == kick && $4 != $hget(cgsb,$+($cgsbsock,.nick))) {
    if ($hget($cgsbsock,$+($3,.limit))) { $+(.timer,$hget(cgsb,$+($cgsbsock,.network)),.,$3,.limit) -o 1 60 limit $cgsbsock $3 }
  }
  elseif ($2 == mode) {
    if ($left($3,1) == $chr(35)) {
      var %add, %del, %extra
      var %a = 1, %b, %c = 1, %d, %e, %mode, %prefix, %nicks = $5-, %host
      while ($mid($4,%a,1)) {
        %b = $ifmatch
        if ($left(%b,1) isin -+) { %prefix = $left(%b,1) }
        else {
          if ($+(%prefix,%b) == +o && $gettok(%nicks,%c,32) == $hget(cgsb,$+($cgsbsock,.nick))) { limit $cgsbsock $3 | break }
          elseif ($+(%prefix,%b) == -l) { limit $cgsbsock $3 | break }
        }
        inc %a
      }
    }
  }
  elseif ($2 == privmsg) {
    var %a = $hget($cgsbsock,access)
    if ($+(:,$hget(cgsb,$+($cgsbsock,.prefix)),*) iswm $4) {
      var %p = $hget(cgsb,$+($cgsbsock,.prefix))
      if ($+(:,%p,limit) == $4) {
        if (%a < $getcom(limit)) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ You do not posses enough access for this command. $chr(3) | return }
        elseif ($5) {
          hadd $cgsbsock $+($3,.limit) $5
          limit $cgsbsock $3
          sockwrite -n $cgsbsock notice %d $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ Limit set to: $+(+,$5,.) $chr(3)
        }
        else {
          hdel $cgsbsock $+($3,.limit)
          if ($ismode($cgsbsock,@,$3)) { sockwrite -n $cgsbsock mode $3 -l }
          sockwrite -n $cgsbsock notice %d $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ Limit setting has been unset. $chr(3)
        }
      }
    }
  }
}
