;TITLE LINK
;AUTHOR entropy
;COMMANDS link(5) delink(5)
;VERSION: 1.3
;HELP link [#chan1] [#chan2]|Links all the specified channels' on all cgsb's servers.|admin
;HELP delink [#chan1] [#chan2]|De-links all the specified channels' on all cgsb's servers.|admin

;============================== ALIASES
alias multicgsb {
  ;$1=initial cgsb,$2=channel,$3=text
  var %a = 1, %b
  var %t = $gettok($hget(cgsb,$+($1,.colors)),1,32), %u = $gettok($hget(cgsb,$+($1,.colors)),2,32)
  var %x = 1, %y
  while ($hget(cgsb,$+(%x,.link))) {
    %y = $replace($ifmatch,$chr(32),$chr(44))
    while ($sock(cgsb*,%a)) {
      %b = $ifmatch
      var %o = 1, %w, %p
      while ($gettok(%y,%o,44)) {
        %w = $ifmatch
        if ($istok($remove($hget(cgsb,$+(%b,.channels)),~,&,%,@,+),%w,32)) {
          %p = $+(%p,$chr(44),%w)
        }
        inc %o
      }
      if (%b != $1 && %p) {
        if ($sock(%b).status == active) { !sockwrite -n %b privmsg %p $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ $+($chr(40),$hget(cgsb,$+($1,.network)),$chr(41)) $2- $chr(3) }
      }
      inc %a
    }
    inc %x
  }
}
alias -l cgsbsock { return $hget(cgsb,socket) | halt }
alias -l newlink {
  var %a = 1, %b
  while (%a <= 900) {
    if (!$hget(cgsb,$+(%a,.link))) { return %a }
    inc %a
  }
}
alias -l islink {
  var %a = 1, %b
  while ($hfind(cgsb,*.link,%a,w).item) {
    %b = $hget(cgsb,$ifmatch)
    if ($istok(%b,$1,32)) { return $true }
    inc %a
  }
}
;============================== EVENTS
on *:signal:link:{
  var %i = $hget(cgsb,buffer), %p = $hget(cgsb,$+($cgsbsock,.prefix))
  var %t = $gettok($hget(cgsb,$+($cgsbsock,.colors)),1,32), %u = $gettok($hget(cgsb,$+($cgsbsock,.colors)),2,32)
  var %a = $hget($cgsbsock,access)
  tokenize 32 %i
  if ($2 == PRIVMSG && $left($3,1) == $chr(35)) {
    var %j = $hget($+($cgsbsock,.,$hget(cgsb,$+($cgsbsock,.network)),.,$3,.nicks),$gettok($mid($1,2,$len($1)),1,33))
    if (:ACTION == $4 && $islink($3)) { multicgsb $cgsbsock * $+($remove(%j,-),$gettok($mid($1,2,$len($1)),1,33)) $mid($5-,1,-1) }
    elseif ($islink($3)) { multicgsb $cgsbsock $+(<,$remove(%j,-),$gettok($mid($1,2,$len($1)),1,33),>) $mid($4-,2,$len($4-)) }

    if ($+(:,%p,link) == $4) {
      if (%a < $getcom(link)) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ You do not posses enough access for this command. $chr(3) | return }
      elseif (!$5) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ You didn't specify a channel and/or wildcard. No linking done. $chr(3) }
      else {
        hadd cgsb $+($newlink,.link) $5-
        %q = $sock(cgsb*,0)
        if (%q > 0) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ Channels: $+($chr(2),$5-,$chr(2)) are now linked on $+($chr(2),%q,$chr(2)) $iif(%q == 1,server.,servers.) $chr(3) }
        else { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ Unable to comply, No connections! $chr(3) }
      }
      sockwrite -n $cgsbsock silence $+(+,$gettok($mid($1,2,$len($1)),1,33))
      .timer -o 1 2 sockwrite -n $cgsbsock silence $+(-,$gettok($mid($1,2,$len($1)),1,33))
    }
    elseif ($+(:,%p,delink) == $4) {
      if (%a < $getcom(delink)) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ You do not posses enough access for this command. $chr(3) | return }
      else {
        var %a = 1, %b, %q = 0
        while ($hfind(cgsb,*.link,%a,w).item) {
          %b = $hget(cgsb,$ifmatch)
          if (%b == $5-) { hdel cgsb $hfind(cgsb,*.link,%a,w).item | break }
          inc %a
        }
        sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ Channels $+($chr(2),$5,$chr(2)) have been de-linked. $chr(3)
      }
    }
  }
  elseif ($2 == join && $islink($remove($3,:))) {
    hadd $cgsbsock $+($remove($3,:),.onjoin) $hget($cgsbsock,$+($remove($3,:),.onjoin)) $gettok($mid($1,2,$len($1)),1,33)
    var %chan = $remove($3,:)
    var %socket = $cgsbsock
    .timer $+ $cgsbsock $+ $remove($3,:) $+ join -om 1 4 on $cgsbsock %chan * [JOIN] $ $+ hget( %socket , $+( %chan ,.onjoin) ) $iif($numtok($hget($cgsbsock,$+(%chan,.onjoin)),32) == 1,host: $gettok($mid($1,2,$len($1)),2,33))
  }
  elseif ($2 == quit) {
    var %a = 1, %b = $remove($hget(cgsb,$+($cgsbsock,.channels)),@,+,~,&,%), %c
    while ($gettok(%b,%a,32)) {
      %c = $ifmatch
      if ($hget($+($cgsbsock,.,$hget(cgsb,$+($cgsbsock,.network)),.,%c,.nicks),$gettok($mid($1,2,$len($1)),1,33)) && $islink(%c)) {
        hadd $cgsbsock $+(%c,.onquit) $hget($cgsbsock,$+(%c,.onquit)) $gettok($mid($1,2,$len($1)),1,33)
        .timer $+ $cgsbsock $+ %c $+ quit -om 1 4 on $cgsbsock %c * [QUIT] $ $+ hget( $cgsbsock , $+( %c ,.onquit) ) $iif($numtok($hget($cgsbsock,$+(%c,.onquit)),32) == 1,host: $gettok($1,2,33)) $iif($4 && $numtok($hget($cgsbsock,$+(%c,.onquit)),32) == 1,msg: $mid($3-,2,$len($3-)))
      }
      inc %a
    }
  }
  elseif ($2 == nick) {
    var %a = 1, %b = $remove($hget(cgsb,$+($cgsbsock,.channels)),@,+,~,&,%), %c
    while ($gettok(%b,%a,32)) {
      %c = $ifmatch
      if ($hget($+($cgsbsock,.,$hget(cgsb,$+($cgsbsock,.network)),.,%c,.nicks),$remove($3,:)) && $islink(%c)) {
        multicgsb $cgsbsock * [NICK] $gettok($mid($1,2,$len($1)),1,33) newnick: $remove($3,:)
      }
      inc %a
    }
  }
  elseif ($2 == part && $islink($3)) { multicgsb $cgsbsock * [PART] $gettok($mid($1,2,$len($1)),1,33) host: $gettok($1,2,33) $iif($mid($4-,2,$len($4-)),msg: $mid($4-,2,$len($4-))) }
  elseif ($2 == mode && $islink($3)) { .timer $+ $cgsbsock $+ $3 $+ mode -om 1 800 multicgsb $cgsbsock * [MODE] $gettok($mid($1,2,$len($1)),1,33) mode: $4- }
  elseif ($2 == kick && $islink($3)) { multicgsb $cgsbsock * [KICK] $gettok($mid($1,2,$len($1)),1,33) kicked: $4 $iif($5-,msg: $mid($5-,2,$len($5-))) }
  elseif ($2 == topic && $islink($3)) { multicgsb $cgsbsock * [TOPIC] $gettok($mid($1,2,$len($1)),1,33) topic: $mid($4-,2,$len($4-)) }
}
alias -l on {
  multicgsb $1 $3-
  hdel $1 $+($2,.onjoin)
  hdel $1 $+($2,.onquit)
}
