;TITLE NEWS
;AUTHOR entropy
;COMMANDS news(2) newssource(2)
;VERSION: 1.3
;HELP news|Syntax: [ON/OFF]|Displays the most current news headlines.|none
;HELP newssource|Syntax: [FEED]|Where feed is: edition,edition_world,edition_africa,edition_americas,edition_asia,edition_europe,edition_meast,edition_us,edition_business,edition_technology,edition_space,edition_entertainment,edition_sport,edition_football,edition_travel,cnn_freevideo,cnn_latest,edition_richardquest,edition_inthefield,edition_untoldstories,edition_mme,edition_ime,edition_securityfiles,edition_weatherfx,edition_pv|Sets the News Source RSS|aop

;============================== ALIASES

alias newsx {
  var %a = $+(newsx.,$r(1,999999999)) 
  sockclose %a
  sockopen %a cnn.com 80
  sockmark %a $1-
}
alias -l cgsbsock { return $hget(cgsb,socket) | halt }
;============================== EVENTS
on *:signal:news:{
  var %h = $hget(cgsb,buffer), %p = $hget(cgsb,$+($cgsbsock,.prefix))
  var %t = $gettok($hget(cgsb,$+($cgsbsock,.colors)),1,32), %u = $gettok($hget(cgsb,$+($cgsbsock,.colors)),2,32)
  var %a = $hget($cgsbsock,access)
  tokenize 32 %h
  if ($2 == join && $hget(cgsb,$+($cgsbsock,.nick)) == $gettok($mid($1,2,$len($1)),1,33) && $hget($cgsbsock,$+($remove($3,:),.news)) == ON) {
    $+(.timer,$remove($3,:),.news) -o 0 300 newsx $cgsbsock $remove($3,:)
  }
  elseif ($2 == privmsg && $left($3,1) == $chr(35) && $+(:,%p,newssource) == $4) {
    var %feeds = edition,edition_world,edition_africa,edition_americas,edition_asia,edition_europe,edition_meast,edition_us,edition_business,edition_technology,edition_space,edition_entertainment,edition_sport,edition_football,edition_travel,cnn_freevideo,cnn_latest,edition_richardquest,edition_inthefield,edition_untoldstories,edition_mme,edition_ime,edition_securityfiles,edition_weatherfx,edition_pv
    if (%a < $getcom(newssource)) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ You do not posses enough access for this command. $chr(3) | return }
    elseif (!$istok(%feeds,$5,44)) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ Invalid Feed! $chr(3) | return }
    else {
      hadd $cgsbsock $+($3,.feed) $5
      if ($hget(news)) { hfree news }
      sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ Feed is now: $+(,$5,) $chr(3)
    }
  }
  elseif ($2 == privmsg && $left($3,1) == $chr(35) && $+(:,%p,news) == $4) {
    if (%a < $getcom(news)) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ You do not posses enough access for this command. $chr(3) | return }
    elseif ($5 != ON && $5 != OFF) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ Invalid Syntax! Syntax: $+(%p,news) [ON/OFF] $chr(3) | return }
    elseif (($5 == ON && $hget($cgsbsock,$+($3,.news)) == ON) || ($5 == OFF && $hget($cgsbsock,$+($3,.news)) == OFF)) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ NEWS is already $5 $+ ! $chr(3) | return }
    hadd $cgsbsock newsnick $gettok($mid($1,2,$len($1)),1,33)
    hadd $cgsbsock newschannel $3
    hadd $cgsbsock $+($3,.news) $5
    sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ News is now: $+(,$5,) $chr(3)
    if ($5 == OFF) { $+(.timer,$3,.news) off | return }
    else { $+(.timer,$3,.news) -o 0 300 newsx $cgsbsock $3 }
    hadd $cgsbsock $+($3,.news) $5
    newsx $cgsbsock $3
    sockwrite -n $cgsbsock silence $+(+,$gettok($mid($1,2,$len($1)),1,33))
    .timer -o 1 2 sockwrite -n $cgsbsock silence $+(-,$gettok($mid($1,2,$len($1)),1,33))
  }
}
on *:sockopen:newsx.*:{
  var %chan = $gettok($sock($sockname).mark,2,32)
  var %sock = $gettok($sock($sockname).mark,1,32)
  var %feed = $hget(%sock,$+(%chan,.feed))
  sockwrite -n $sockname GET $+(/rss/,$iif(%feed,$ifmatch,edition),.rss) HTTP 1.1
  sockwrite -n $sockname Host: $+(www.mirc.com,$str($crlf,2))
}
on *:sockread:newsx.*:{
  var %a
  sockread -f %a
  tokenize 32 %a
  if (<title>*</title> iswm $1- && <title>CNN.com</title> != $1) { 
    if (!$hfind($+(news,$gettok($sock($sockname).mark,1,32)),$remove($1-,<title>,</title>),1,w).data) { hadd -m $+(news,$gettok($sock($sockname).mark,1,32)) $+(total,$gettok($sock($sockname).mark,1,32)) $hget(news,$+(total,$gettok($sock($sockname).mark,1,32))) $iif($hget(news,$+(total,$gettok($sock($sockname).mark,1,32))),-) $remove($1-,<title>,</title>) | hadd -m $+(news,$gettok($sock($sockname).mark,1,32)) $r(1000000000,9999999999) $remove($1-,<title>,</title>) }
  }
}
on *:sockclose:newsx.*:{ if ($hget($+(news,$gettok($sock($sockname).mark,1,32)),$+(total,$gettok($sock($sockname).mark,1,32)))) { sockwrite -n $gettok($sock($sockname).mark,1,32) privmsg $gettok($sock($sockname).mark,2,32) :[NEWS] $hget($+(news,$gettok($sock($sockname).mark,1,32)),$+(total,$gettok($sock($sockname).mark,1,32))) } | hdel $+(news,$gettok($sock($sockname).mark,1,32)) $+(total,$gettok($sock($sockname).mark,1,32)) }
