;TITLE TIME
;AUTHOR entropy
;COMMANDS time(0)
;VERSION: 1.1
;HELP time [location]|Finds current local time of location.|none

;============================== ALIASES
alias -l time { 
  var %a = $+(time.,$r(1,999999999999999999999999999))
  sockopen %a www.timeanddate.com 80
  sockmark %a $1 $remove($2-,$chr(44))
  %z = ""
}
alias -l striphtml {
  var %p = 1, %b = $replace($1-,$chr(38),$+($chr(32),$chr(38)),;,$+(;,$chr(32)),>,$+(>,$chr(32)),<,$+($chr(32),<,)), %c
  while ($gettok(%b,%p,32)) {
    %c = $ifmatch
    if (*<* iswm %c || *&*; iswm %c || *</* iswm %c || *solid* iswm %c || *px* iswm %c || *:* iswm %c && $remove(%c,:) !isnum || */* iswm %c || *'* iswm %c || *;* iswm %c || *&* iswm %c || *<*>* iswm %c || *=* iswm %c || *"* iswm %c || *>* iswm %c || $+(*,$chr(40),*) iswm %c || $+(*,$chr(41),*) iswm %c || $+(*,$chr(123),*) iswm %c || $+(*,$chr(125),*) iswm %c) { %b = $remove(%b,%c) | %p = 0 }
    inc %p
  }
  return %b
}
alias -l endtime {
  var %t = $gettok($hget(cgsb,$+($1,.colors)),1,32), %u = $gettok($hget(cgsb,$+($1,.colors)),2,32)
  if ($1 && $2) {
    sockwrite -n $1 privmsg $hget($1,timechannel) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ Time: $2- $chr(3)
  }
  else { sockwrite -n $1 notice $hget($1,timenick) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ No results found. $chr(3) }
  unset %z
}
alias -l cgsbsock { return $hget(cgsb,socket) | halt }
;============================== EVENTS
on *:signal:time:{
  var %z = $hget(cgsb,buffer), %p = $hget(cgsb,$+($cgsbsock,.prefix))
  var %t = $gettok($hget(cgsb,$+($cgsbsock,.colors)),1,32), %u = $gettok($hget(cgsb,$+($cgsbsock,.colors)),2,32)
  var %a = $hget($cgsbsock,access)
  tokenize 32 %z
  if ($2 == privmsg && $left($3,1) == $chr(35) && $+(:,%p,*) iswm $4) {
    if ($+(:,%p,time) == $4) {
      if (%a < $getcom(time)) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ You do not posses enough access for this command. $chr(3) | return }
      elseif (!$5) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ No location specified. $chr(3) }
      else {
        hadd $cgsbsock timenick $gettok($mid($1,2,$len($1)),1,33)
        hadd $cgsbsock timechannel $3
        time $cgsbsock $5-
      }
      sockwrite -n $cgsbsock silence $+(+,$gettok($mid($1,2,$len($1)),1,33))
      .timer -o 1 2 sockwrite -n $cgsbsock silence $+(-,$gettok($mid($1,2,$len($1)),1,33))
    }
  }
}
on *:sockopen:time.*:{
  var %t = $gettok($hget(cgsb,$+($gettok($sock($sockname).mark,1,32),.colors)),1,32), %u = $gettok($hget(cgsb,$+($gettok($sock($sockname).mark,1,32),.colors)),2,32)
  if ($sockerr > 0) { sockwrite -n $gettok($sock($sockname).mark,1,32) notice $hget($gettok($sock($sockname).mark,1,32),timenick) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ Socket error(s). Try again later. $chr(3) | return } 
  var %m = $gettok($sock($sockname).mark,2-,32)
  sockwrite -n $sockname GET $+(/worldclock/results.html?query=,$replace(%m,$chr(32),+)) HTTP/1.1
  sockwrite -n $sockname Host: $+(www.timeanddate.com,$str($crlf,2))
}
on *:sockread:time.*:{
  var %t = $gettok($hget(cgsb,$+($gettok($sock($sockname).mark,1,32),.colors)),1,32), %u = $gettok($hget(cgsb,$+($gettok($sock($sockname).mark,1,32),.colors)),2,32)
  var %a
  sockread -f %a
  %a = $mid(%a,1,800)
  %a = $remove(%a,Set your preferred time and date formats)
  %a = $remove(%a,- e.g.,12,hour,24,$+(or,$chr(32)))
  tokenize 32 %a
  if (*href="city.html?n=*">* iswm $1- && !%z) { %z = $iif($left($striphtml($1-),1) == -,$gettok($striphtml($1-),2-,32),$striphtml($1-)) }
  if ($regex(td,$1-,<br /></td></tr></table><br /><table class="border2" cellpadding="10" cellspacing="0" border="0" align="center"><tr><th class="head" colspan="2"><span class="biggest">(.*?)</span><br />.*?</th></tr><tr class="d0"><th>Current time</th><td><strong id="ct">(.*?)</strong></td></tr><tr class="d1"><th>UTC/GMT Offset</th><td id="tz1"><table border="0" cellpadding="2" cellspacing="0"><tr><td>Standard time zone:</td><td>(.*?)</td></tr><tr><td>Daylight saving time:</td><td>(.*?)</td></tr><tr><td>Current time zone offset:</td><td><strong>(.*?)</strong></td></tr>)) {
    %z = $striphtml(Location: $regml(td,1) - Current time: $regml(td,2) - Standard time zone: $regml(td,3) - Daylight saving time: $regml(td,4) - Current time zone offset: $regml(td,5))
  }
  if ($regex(td,$1-,<br /></td></tr></table><br /><table class="border2" cellpadding="10" cellspacing="0" border="0" align="center"><tr><th class="head" colspan="2"><span class="biggest">(.*?)</span><br />.*?</th></tr><tr class="d0"><th>Current time</th><td><strong id="ct">(.*?)</strong></td></tr><tr class="d1"><th>UTC/GMT Offset</th><td id="tz1"><table border="0" cellpadding="2" cellspacing="0"><tr><td>Standard time zone:</td><td>(.*?)</td></tr><tr><td colspan="2">(.*?)</td></tr></table>)) {
    %z = $striphtml(Location: $regml(td,1) - Current time: $regml(td,2) - Standard time zone: $regml(td,3) - Daylight saving time: $regml(td,4))
  }
  .timerendtime -o 1 1 endtime $gettok($sock($sockname).mark,1,32) %z
}
