;TITLE TOPICLOCK
;AUTHOR entropy
;COMMANDS topiclock(2)
;VERSION: 1.1
;HELP topiclock [topic]|Locks channel topic to topic specified. Supply nothing to unset this value.|aop

;============================== ALIASES
alias -l ismode {
  ;$1=sockname,$2=mode,$3=channel
  if ($2 isin $hget($+($1,.,$hget(cgsb,$+($1,.network)),.,$3,.nicks),$hget(cgsb,$+($1,.nick)))) { return $true }
}
alias -l isadmin {
  var %a = 1, %b
  while ($hfind($1,*.admin,%a,w).item) {
    %b = $remove($ifmatch,.admin)
    if ($2 iswm %b || %b iswm $2) { return $true }
    inc %a
  }
}
alias -l getaccess {
  var %a = 1, %b, %c = $iif(@ !isin $3,$+($3,!,$hget($1,$+($3,.host))),$3), %d,%e, %f
  while ($hfind($1,$+(*,.,$2,.access),%a,w).item) {
    %f = $ifmatch
    %b = $remove(%f,$+(.,$2),.access,$+(.,$hget(cgsb,$+($1,.network)))))
    %e = $hget($1,%f)
    if (%c iswm %b || %b iswm %c) { %d = $addtok(%d,%e,32) }
    inc %a
  }
  var %z = 1, %x, %y
  while ($gettok(%d,%z,32)) {
    %x = $ifmatch
    if (!%y || %x > %y) { %y = %x }
    inc %z
  }
  return %y
}
alias -l cgsbsock { return $hget(cgsb,socket) | halt }
;============================== EVENTS
on *:signal:topiclock:{
  var %z = $hget(cgsb,buffer), %p = $hget(cgsb,$+($cgsbsock,.prefix))
  var %t = $gettok($hget(cgsb,$+($cgsbsock,.colors)),1,32), %u = $gettok($hget(cgsb,$+($cgsbsock,.colors)),2,32)
  tokenize 32 %z
  if ($2 == topic) {
    hadd $cgsbsock $+($3,.topic) $mid($4-,2,$len($4-))
    if ($hget($cgsbsock,$+($3,.topiclock)) && $hget($cgsbsock,$+($3,.topiclock)) != $mid($4-,2,$len($4-)) && $ismode($cgsbsock,@,$3)) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) :The channel topic is currently locked. | sockwrite -n $cgsbsock topic $3 $+(:,$hget($cgsbsock,$+($3,.topiclock))) }
  }
  elseif ($2 == 353) {
    if ($remove($6-,:) == $+(@,$hget(cgsb,$+($cgsbsock,.nick)))) {
      if ($hget($cgsbsock,$+($5,.topiclock))) { sockwrite -n $cgsbsock topic $5 $+(:,$ifmatch) }
    }
  }
  elseif ($2 == privmsg && $left($3,1) == $chr(35) && $+(:,%p,*) iswm $4) {
    var %a = $hget($cgsbsock,access)
    if ($+(:,%p,topiclock) == $4) {
      if (%a < $getcom(topiclock)) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ You do not posses enough access for this command. $chr(3) | return }
      elseif (!$5) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u))) $+ topiclock has been unset. | hdel $cgsbsock $+($3,.topiclock) | if ($ismode($cgsbsock,@,$3)) { sockwrite -n $cgsbsock topic $3 "" } }
      else { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u))) $+ topiclock is now $+(,$5-,.) | hadd $cgsbsock $+($3,.topiclock) $5- | if ($ismode($cgsbsock,@,$3)) { sockwrite -n $cgsbsock topic $3 $+(:,$5-) } } 
      sockwrite -n $cgsbsock silence $+(+,$gettok($mid($1,2,$len($1)),1,33))
      .timer -o 1 3 sockwrite -n $cgsbsock silence $+(-,$gettok($mid($1,2,$len($1)),1,33))
    }
  }
  elseif ($2 == mode) {
    if ($left($3,1) == $chr(35)) {
      var %add, %del, %extra
      var %a = 1, %b, %c = 1, %d, %e, %mode, %prefix, %nicks = $5-, %host
      while ($mid($4,%a,1)) {
        %b = $ifmatch
        if ($left(%b,1) isin -+) { %prefix = $left(%b,1) }
        else {
          if ($+(%prefix,%b) == +o) {
            if ($hget(cgsb,$+($cgsbsock,.nick)) == $gettok(%nicks,%c,32)) {
              if ($hget($cgsbsock,$+($3,.topiclock)) != $hget($cgsbsock,$+($3,.topic)) && $hget($cgsbsock,$+($3,.topiclock))) { sockwrite -n $cgsbsock topic $3 $+(:,$hget($cgsbsock,$+($3,.topiclock))) }
            }
          }
          inc %c
        }
        inc %a
      }
    }
  }
