;TITLE WEATHER
;AUTHOR entropy
;COMMANDS weather(0)
;VERSION: 1.6
;HELP weather [location]|Looks up weather for location.|none

;============================== ALIASES
alias -l compressedtime {
  return $remove($replace($duration($calc($ctime - $1)),wks,w,wk,w,days,d,day,d,hrs,h,hr,h,mins,m,min,m,secs,s,sec,s),$chr(32))
}
alias -l dur {
  return $remove($replace($duration($1),wks,w,wk,w,days,d,day,d,hrs,h,hr,h,mins,m,min,m,secs,s,sec,s),$chr(32))
}
alias -l weather {
  var %a = $r(1,99999)
  sockopen $+(weather.,%a) www.wunderground.com 80
  sockmark $+(weather.,%a) $1-
}

alias -l striphtml {
  var %p = 1, %b = $replace($mid($1-,1,800),$chr(38),$+($chr(32),$chr(38)),;,$+(;,$chr(32)),>,$+(>,$chr(32)),<,$+($chr(32),<,)), %c
  while ($gettok(%b,%p,32)) {
    %c = $ifmatch
    if (*<* iswm %c || *&*; iswm %c || *</* iswm %c || *solid* iswm %c || *px* iswm %c || *:* iswm %c && $remove(%c,:) !isnum || */* iswm %c || *'* iswm %c || *;* iswm %c || *&* iswm %c || *<*>* iswm %c || *=* iswm %c || *"* iswm %c || *>* iswm %c || $+(*,$chr(40),*) iswm %c || $+(*,$chr(41),*) iswm %c || $+(*,$chr(123),*) iswm %c || $+(*,$chr(125),*) iswm %c) { %b = $remove(%b,%c) | %p = 0 }
    inc %p
  }
  return $remove(%b,<sup>,</sup>)
}
alias -l cgsbsock { return $hget(cgsb,socket) | halt }
;============================== EVENTS
on *:signal:weather:{
  var %z = $hget(cgsb,buffer), %p = $hget(cgsb,$+($cgsbsock,.prefix))
  var %t = $gettok($hget(cgsb,$+($cgsbsock,.colors)),1,32), %u = $gettok($hget(cgsb,$+($cgsbsock,.colors)),2,32)
  tokenize 32 %z
  if ($+(:,%p,weather) == $4) {
    if (%a < $getcom(weather)) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ You do not posses enough access for this command. $chr(3) | return }
    elseif (!$5 && !$hget($cgsbsock,$+($gettok($mid($1,2,$len($1)),1,33),.location))) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ No location specified. $chr(3) }
    else {
      if ((!$hget($cgsbsock,$+($gettok($mid($1,2,$len($1)),1,33),.location))) || ($hget($cgsbsock,$+($gettok($mid($1,2,$len($1)),1,33),.location)) != $replace($5-,$chr(32),+) && $5)) { hadd -m $cgsbsock $+($gettok($mid($1,2,$len($1)),1,33),.location) $replace($5-,$chr(32),+) }
      hadd -m $cgsbsock $+($gettok($mid($1,2,$len($1)),1,33),.chan) $3
      weather $cgsbsock $gettok($mid($1,2,$len($1)),1,33) $hget($cgsbsock,$+($gettok($mid($1,2,$len($1)),1,33),.location))
      %nick = $gettok($mid($1,2,$len($1)),1,33)
    }
    sockwrite -n $cgsbsock silence $+(+,$gettok($mid($1,2,$len($1)),1,33))
    .timer -o 1 2 sockwrite -n $cgsbsock silence $+(-,$gettok($mid($1,2,$len($1)),1,33))
  }
}
on *:sockopen:weather.*:{
  var %t = $gettok($hget(cgsb,$+($sockname,.colors)),1,32), %u = $gettok($hget(cgsb,$+($sockname,.colors)),2,32)
  if ($sockerr > 0) { sockwrite -n $gettok($sock($sockname).mark,1,32) notice $gettok($sock($sockname).mark,2,32) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u))) Socket error(s). Try again later. $chr(3) | return }
  sockwrite -n $sockname GET $+(  http://www.wunderground.com/cgi-bin/findweather/getForecast?brand=sfgate&query=,$gettok($sock($sockname).mark,3-,32)) HTTP/1.1
  sockwrite -n $sockname Host: $+(weather.lycos.com,$str($crlf, 2))
}
on *:sockread:weather.*:{
  var %t = $gettok($hget(cgsb,$+($sockname,.colors)),1,32), %u = $gettok($hget(cgsb,$+($sockname,.colors)),2,32)
  if ($sockerr > 0) { sockwrite -n $gettok($sock($sockname).mark,1,32) notice $gettok($sock($sockname).mark,2,32) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u))) Socket error(s). Try again later. $chr(3) | return }
  var %x
  sockread -f %x
  tokenize 32 $mid(%x,1,840)
  if (<font size="4" color="000099">*</font></font></td></tr></table> iswm $1-) { hadd $gettok($sock($sockname).mark,1,32) $+($gettok($sock($sockname).mark,2,32),.temp) $remove($replace($3-,&deg;,),color="000099">,</font></font></td></tr></table>) }
  if (<font face="helvetica,arial,sans-serif" color="#333399" size=4><b>&nbsp;*</b></font><br> iswm $1-) { hadd $gettok($sock($sockname).mark,1,32) $+($gettok($sock($sockname).mark,2,32),.temp) $replace($remove($1-,<font face="helvetica,arial,sans-serif" color="#333399" size=4><b>&nbsp;,</b></font><br>,$chr(44)),&deg;,) }
  if (<font color="#333399" face="geneva,arial,sans-serif" size=1><b>*</b><br> iswm $1-) { hadd $gettok($sock($sockname).mark,1,32) $+($gettok($sock($sockname).mark,2,32),.condition) $remove($1-,<font color="#333399" face="geneva,arial,sans-serif" size=1><b>,</b><br>) }
  if (Wind: <b>*</b><br> iswm $1-) { hadd $gettok($sock($sockname).mark,1,32) $+($gettok($sock($sockname).mark,2,32),.wind) $remove($1-,Wind: <b>,</b><br>) }
  if (Humidity: <b>*</b><br> iswm $1-) { hadd $gettok($sock($sockname).mark,1,32) $+($gettok($sock($sockname).mark,2,32),.humidity) $replace($remove($1-,Humidity:,<b>,</b><br>),&deg;,) }
  if ($1 == Dewpoint:) {
    if (<b>*</b> iswm $2) { hadd $gettok($sock($sockname).mark,1,32) $+($gettok($sock($sockname).mark,2,32),.dew) $+($remove($2,<b>,</b>),F) }
    if (*<br>Pressure: iswm $3) {
      hadd $gettok($sock($sockname).mark,1,32) $+($gettok($sock($sockname).mark,2,32),.pressure) $remove($4,<b>,</b><br>)
    }
    if (Clouds: == $5) {
      hadd $gettok($sock($sockname).mark,1,32) $+($gettok($sock($sockname).mark,2,32),.clouds) $remove($6-,<b>,<br>,</b>) 
    }
    if ($findtok($1-,<br>Visibility:,1,32)) {
      var %k = $gettok($1-,$+($findtok($1-,<br>Visibility:,1,32),-),32)
      %k = $remove(%k,<b>,</b>)
      hadd $gettok($sock($sockname).mark,1,32) $+($gettok($sock($sockname).mark,2,32),.vis) %k
    }
  }
  .timer $+ $sockname -o 1 1 endweather $sockname $gettok($sock($sockname).mark,1,32) $gettok($sock($sockname).mark,2,32)
}
alias -l endweather {
  var %t = $gettok($hget(cgsb,$+($1,.colors)),1,32), %u = $gettok($hget(cgsb,$+($1,.colors)),2,32)
  if (!$hget($2,$+($3,.temp))) { sockwrite -n $2 notice %nick $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ Nothing found. $chr(3) | unset %nick | return }
  var %m = Weather: $replace($hget($2,$+($3,.location)),+,$chr(32)) Condition: $remove($hget($2,$+($3,.condition)),$chr(44)) Temp: $remove($hget($2,$+($3,.temp)),</font></font></td></tr></table>) Humidity: $hget($2,$+($3,.humidity)) Dew Point: $remove($hget($2,$+($3,.dew)),&deg;) $iif($hget($2,$+($3,.vis)),Visibility: $remove($hget($2,$+($3,.vis)),<br>Visibility:)) Wind: $hget($2,$+($3,.wind))
  sockwrite -n $2 privmsg $hget($2,$+($3,.chan)) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ %m $chr(3)
  endweather2 entropy $2-3
}
alias -l endweather2 {
  hdel $2 $+($3,.temp)
  hdel $2 $+($3,.humidity)
  hdel $2 $+($3,.dew)
  hdel $2 $+($3,.condition)
  hdel $2 $+($3,.vis)
  hdel $2 $+($3,.wind)
  hdel $2 $+($3,.clouds)
  unset %nick
}
