;TITLE WIKI
;AUTHOR entropy
;COMMANDS wiki(0)
;VERSION: 1.1
;HELP wiki [words]|Defines words on channel via wikipedia.|none

;============================== ALIASES


alias -l wiki {
  sockclose wiki
  sockopen wiki en.wikipedia.org 80
  var %a = 1, %b, %c = $replace($2-,_,$chr(32)), %d
  while ($gettok(%c,%a,32)) {
    %d = $ifmatch
    %b = %b $+($upper($left(%d,1)),$mid(%d,2,$len($ifmatch)))
    inc %a
  }
  sockmark wiki $1 %b
}

alias -l destroywiki {
  hdel $1 wikivalue
  hdel $1 wikiword
  hdel $1 wikichannel
  hdel $1 wikinick
  hdel $1 wikiword
  hdel $1 wikifinish
  hdel $1 wikicontinue
}
alias -l striphtml {
  var %p = 1, %b = $replace($mid($1-,1,420),$chr(38),$+($chr(32),$chr(38)),;,$+(;,$chr(32)),>,$+(>,$chr(32)),<,$+($chr(32),<,)), %c
  while ($gettok(%b,%p,32)) {
    %c = $ifmatch
    if (*<* iswm %c || *&*; iswm %c || *</* iswm %c || *solid* iswm %c || *px* iswm %c || *:* iswm %c && $remove(%c,:) !isnum || */* iswm %c || *'* iswm %c || *;* iswm %c || *&* iswm %c || *<*>* iswm %c || *=* iswm %c || *"* iswm %c || *>* iswm %c || $+(*,$chr(40),*) iswm %c || $+(*,$chr(41),*) iswm %c || $+(*,$chr(123),*) iswm %c || $+(*,$chr(125),*) iswm %c) { %b = $remove(%b,%c) | %p = 0 }
    inc %p
  }
  return %b
}
alias -l cgsbsock { return $hget(cgsb,socket) | halt }

;============================== EVENTS
on *:signal:wiki:{
  var %i = $hget(cgsb,buffer), %p = $hget(cgsb,$+($cgsbsock,.prefix))
  var %t = $gettok($hget(cgsb,$+($cgsbsock,.colors)),1,32), %u = $gettok($hget(cgsb,$+($cgsbsock,.colors)),2,32)
  var %a = $hget($cgsbsock,access)
  tokenize 32 %i
  if ($+(:,%p,wiki) == $4) {
    if (%a < $getcom(wiki)) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ You do not posses enough access for this command. $chr(3) | return }
    elseif (!$5) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ No wiki specified. $chr(3) }
    else {
      hadd $cgsbsock wikinick $gettok($mid($1,2,$len($1)),1,33)
      hadd $cgsbsock wikichannel $3
      hadd $cgsbsock wikiword $5-
      wiki $cgsbsock $5-
    }
    sockwrite -n $cgsbsock silence $+(+,$gettok($mid($1,2,$len($1)),1,33))
    .timer -o 1 2 sockwrite -n $cgsbsock silence $+(-,$gettok($mid($1,2,$len($1)),1,33))
  }
}
on *:sockopen:wiki:{
  var %t = $gettok($hget(cgsb,$+($sockname,.colors)),1,32), %u = $gettok($hget(cgsb,$+($sockname,.colors)),2,32)
  if ($sockerr > 0) { sockwrite -n $gettok($sock($sockname).mark,1,32) notice $hget($gettok($sock($sockname).mark,1,32),wikinick) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ Socket error(s). Try again later. $chr(3) | return }
  sockwrite -n $sockname GET $+(http://en.wikipedia.org/wiki/,$remove($replace($gettok($sock($sockname).mark,2-,32),$chr(32),_),?)) HTTP/1.1 $+ $crlf
  sockwrite -n $sockname Host: en.wikipedia.org $+ $crlf
  sockwrite -n $sockname Connection: close $+ $crlf
  sockwrite -n $sockname Accept: image/gif, image/x-xbitmap, image/jpeg, image/pjpeg, application/x-shockwave-flash, application/vnd.ms-excel, application/msword, application/vnd.ms-powerpoint, */* $+ $crlf
  sockwrite -n $sockname Accept-Language: en-us $+ $crlf
  sockwrite -n $sockname User-Agent: Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1; SV1; .NET CLR 2.0.50727) Web-Sniffer/1.0.24 $+ $crlf
  sockwrite -n $sockname Referer: http://web-sniffer.net/ $+ $crlf $+ $crlf
}

on *:sockread:wiki:{
  var %t = $gettok($hget(cgsb,$+($sockname,.colors)),1,32), %u = $gettok($hget(cgsb,$+($sockname,.colors)),2,32)
  if ($sockerr > 0) { sockwrite -n $gettok($sock($sockname).mark,1,32) notice $hget($gettok($sock($sockname).mark,1,32),wikinick) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ Socket error(s). Try again later. $chr(3) | return }
  var %a, %b
  sockread -f %a
  %a = $mid(%a,1,420)
  tokenize 32 %a
  if (<p>* iswm $1- && !%found) { %found = Y | %answer = $striphtml($1-) }
  elseif (%found == Y && $calc($len(%answer) + $len($striphtml($1-))) < 420) { %answer = %answer $striphtml($1-) }
  elseif ($calc($len(%answer) + $len($striphtml($1-))) >= 420) { .timerwiki off | closewiki $sock($sockname).mark | sockclose wiki | return }
  .timerwiki -o 1 2 closewiki $sock($sockname).mark
}
alias -l closewiki {
  if (%answer) {
    var %n = $iif($len(%answer) >= 420,$+($mid(%answer,1,420),...),%answer)
    sockwrite -n $1 privmsg $hget($1,wikichannel) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ wiki: %n $chr(3)
    unset %answer
    unset %found
    destroywiki $1
  }
  else { sockwrite -n $1 notice $hget($1,wikinick) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ Nothing found. $chr(3) | unset %answer | unset %found | destroywiki $1 }
}
