;TITLE AWAYDEOP
;AUTHOR entropy
;COMMANDS awaydeop(3)
;VERSION: 1.1
;HELP awaydeop|Deops all ops if they are away.|sop

;============================== ALIASES
alias -l ismode {
  ;$1=sockname,$2=mode,$3=channel
  if ($2 isin $hget($+($1,.,$hget(cgsb,$+($1,.network)),.,$3,.nicks),$hget(cgsb,$+($1,.nick)))) { return $true }
}
alias -l isothermode {
  ;$1=sockname,$2=mode,$3=channel,$4=nick
  if ($2 isin $hget($+($1,.,$hget(cgsb,$+($1,.network)),.,$3,.nicks),$4)) { return $true }
}
alias -l appendmode {
  ;appendmode socket channel modes nicks
  var %x = 1, %y = $4-, %z
  while ($gettok(%y,%x,32)) { 
    %z = %z $ifmatch
    if ($numtok(%z,32) == $hget(cgsb,$+($1,.modes)) || %x == $numtok(%y,32)) { sockwrite -n $1 mode $2 $left($3,1) $+ $str($mid($3,2,1),$numtok(%z,32)) %z | %z = "" }
    inc %x
  }
}
alias -l isadmin {
  var %b
  if ($hfind($1,$+($2,.admin),1,w).item) {
    %b = $remove($hfind($1,$+($2,.admin),1,w).item,.admin)
    if ($2 iswm %b || %b iswm $2) { return $true }
  }
  elseif ($hfind($1,$+($2,.admin),1,W).item) {
    %b = $remove($hfind($1,$+($2,.admin),1,W).item,.admin)
    if ($2 iswm %b || %b iswm $2) { return $true }
  }
}
alias -l getaccess {
  var %a = 1, %b, %c = $iif(@ !isin $3,$+($3,!,$hget($1,$+($3,.host))),$3), %d,%e, %f, %x = 2, %y
  if ($hfind($1,$+(%c,.,$2,.access),1,W).item) {
    %y = $hget($1,$ifmatch)
    while ($hfind($1,$+(%c,.,$2,.access),%x,W).item) {
      %f = $hget($1,$hfind($1,$+(%c,.,$2,.access),%x,W).item)
      if (%f > %y) { %y = %f }
      inc %x
    }
    return %y
  }
}
alias -l cgsbsock { return $hget(cgsb,socket) | halt }
;============================== EVENTS
on *:signal:awaydeop:{
  var %d = $hget(cgsb,buffer)
  var %t = $gettok($hget(cgsb,$+($cgsbsock,.colors)),1,32), %u = $gettok($hget(cgsb,$+($cgsbsock,.colors)),2,32)
  var %a = $hget($cgsbsock,access)
  tokenize 32 %d
  if ($2 == join && $gettok($mid($1,2,$len($1)),1,33) == $hget(cgsb,$+($cgsbsock,.nick)) && $hget($cgsbsock,$+($remove($3,:),.awaydeop))) {
    .timer $+ $cgsbsock $+ $remove($3,:) $+ awaydeop -o 0 180 sockwrite -n $cgsbsock who $remove($3,:)
  }
  elseif ($2 == part && $gettok($mid($1,2,$len($1)),1,33) == $hget(cgsb,$+($cgsbsock,.nick))) {
    .timer $+ $cgsbsock $+ $remove($3,:) $+ awaydeop off
  }
  elseif ($2 == kick && $4 == $hget(cgsb,$+($cgsbsock,.nick))) {
    .timer $+ $cgsbsock $+ $remove($3,:) $+ awaydeop off
  }
  elseif ($2 == privmsg) {
    if ($+(:,$hget(cgsb,$+($cgsbsock,.prefix)),*) iswm $4) {
      var %p = $hget(cgsb,$+($cgsbsock,.prefix))
      if ($+(:,%p,awaydeop) == $4) {
        if (%a < $getcom(awaydeop)) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ You do not posses enough access for this command. $chr(3) | return }
        if ($hget($cgsbsock,$+($3,.awaydeop))) { var %added = n | hdel $cgsbsock $+($3,.awaydeop) }
        else { var %added = y | hadd $cgsbsock $+($3,.awaydeop) $ctime | sockwrite -n $cgsbsock who $3 }
        sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ Away deop is now $+(,$iif(%added = y,On,Off),) $chr(3)
        if (%added == y) { .timer $+ $cgsbsock $+ $3 $+ awaydeop -o 0 180 sockwrite -n $cgsbsock who $3 }
        sockwrite -n $cgsbsock silence $+(+,$gettok($mid($1,2,$len($1)),1,33))
        .timer -o 1 2 sockwrite -n $cgsbsock silence $+(-,$gettok($mid($1,2,$len($1)),1,33))
      }
    }
  }
  elseif ($2 == 352) {
    var %host = $+($8,!,$hget($cgsbsock,$+($8,.host)))
    var %a = $iif($isadmin($cgsbsock,%host),5,$iif($getaccess($cgsbsock,$4,%host),$ifmatch,0))
    if (G isin $9 && $hget($cgsbsock,$+($4,.awaydeop)) && $ismode($cgsbsock,@,$4) && $isothermode($cgsbsock,@,$4,$8) && %a <= 1 && $8 != $hget(cgsb,$+($cgsbsock,.nick))) { hadd $cgsbsock $+($4,.awaydeopnicks) $addtok($hget($cgsbsock,$+($4,.awaydeopnicks)),$8,32) }
  }
  elseif ($2 == 315) {
    appendmode $cgsbsock $4 -o $hget($cgsbsock,$+($4,.awaydeopnicks))
    hdel $cgsbsock $+($4,.awaydeopnicks)
  }
}
