;TITLE LOG
;AUTHOR entropy
;COMMANDS log(0)
;VERSION: 1.3
;HELP log [wildcard]|Returns any logs matching wildtext.|none

;============================== ALIASES
alias -l compressedtime {
  return $remove($replace($duration($calc($ctime - $1)),wks,w,wk,w,days,d,day,d,hrs,h,hr,h,mins,m,min,m,secs,s,sec,s),$chr(32))
}
alias -l cgsblog {
  hadd -m $+($1,.log) $+($1,.,$hget(cgsb,$+($1,.network)),.,$2,.,$ticks) $+($chr(40),$time(h:nn:sstt),/,$replace($adate,/,-),$chr(41)) $3-
}
alias -l cgsbsock { return $hget(cgsb,socket) | halt }

;============================== EVENTS

on *:signal:log:{
  var %z = $hget(cgsb,buffer), %p = $hget(cgsb,$+($cgsbsock,.prefix))
  var %t = $gettok($hget(cgsb,$+($cgsbsock,.colors)),1,32), %u = $gettok($hget(cgsb,$+($cgsbsock,.colors)),2,32)
  var %a = $hget($cgsbsock,access)
  tokenize 32 %z
  if ($2 == join && $gettok($mid($1,2,$len($1)),1,33) != $hget(cgsb,$+($cgsbsock,.nick))) {
    cgsblog $cgsbsock $remove($3,:) * [join] $gettok($mid($1,2,$len($1)),1,33) $+($chr(40),$gettok($mid($1,2,$len($1)),2,33),$chr(41))
  }
  elseif ($2 == quit && $gettok($mid($1,2,$len($1)),1,33) != $hget(cgsb,$+($cgsbsock,.nick))) {
    var %a = 1, %b, %c = $gettok($mid($1,2,$len($1)),1,33),%chans = $hget(cgsb,$+($cgsbsock,.channels))
    while ($gettok(%chans,%a,32)) {
      %b = $ifmatch
      cgsblog $cgsbsock %b * [quit] %c $+($chr(40),$gettok($mid($1,2,$len($1)),2,33),$chr(41)) Quit $iif($mid($3,2,$len($3)),$+($chr(40),$mid($3-,2,$len($3-)),$chr(41)))
      inc %a
    }
  }
  elseif ($2 == topic) {
    cgsblog $cgsbsock $3 * [topic] $gettok($mid($1,2,$len($1)),1,33) sets $remove($3,:) topic: $+(',$mid($4-,2,$len($4-)),')
  }
  elseif ($2 == mode && $remove($3,:) != $hget(cgsb,$+($cgsbsock,.nick))) {
    cgsblog $cgsbsock $3 * [mode] $gettok($mid($1,2,$len($1)),1,33) sets mode: $4-
  }
  elseif ($2 == part && $gettok($mid($1,2,$len($1)),1,33) != $hget(cgsb,$+($cgsbsock,.nick))) {
    cgsblog $cgsbsock * [part] $gettok($mid($1,2,$len($1)),1,33) $+($chr(40),$gettok($mid($1,2,$len($1)),2,33),$chr(41)) $iif($mid($4-,2,$len($4-)),$+($chr(40),$mid($4-,2,$len($4-)),$chr(41)))
  }
  elseif ($2 == kick && $4 != $hget(cgsb,$+($cgsbsock,.nick))) {
    cgsblog $cgsbsock $3 * [kick] $gettok($mid($1,2,$len($1)),1,33) $+($chr(40),$gettok($mid($1,2,$len($1)),2,33),$chr(41)) has kicked $4 $iif($5-,$+($chr(40),$mid($5-,2,$len($5-)),$chr(41)))
  }
  elseif ($2 == privmsg && $left($3,1) == $chr(35) && $+(:,%p,*) iswm $4) {
    var %find = *(*:*:*/*-*-*)*
    if ($+(:,%p,log) == $4) {
      if (%a < $getcom(log)) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ You do not posses enough access for this command. $chr(3) | return }
      elseif (!$5) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ No wildcard specified. $chr(3) }
      elseif ($hfind($+($cgsbsock,.log),$+(%find,$remove($replace($strip($5-),$chr(32),*),~,&,@,%,+),*),0,w).data > 5) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ Search criteria too broad. $chr(3) }
      elseif ($hfind($+($cgsbsock,.log),$+(%find,$remove($replace($strip($5-),$chr(32),*),~,&,@,%,+),*),1,w).data) {
        var %a = 1, %g = 0, %b, %c
        while ($hfind($+($cgsbsock,.log),$+(%find,$remove($replace($strip($5-),$chr(32),*),~,&,@,%,+),*),%a,w).data) {
          %c = $ifmatch
          inc %g 2
          %b = $hget($+($cgsbsock,.log),%c)
          .timer -o 1 %g sockwrite -n $cgsbsock privmsg $3 $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ $+([,%a,]) %b $chr(3)
          inc %a
        }
      }
      else { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ No log found. $chr(3) }
      sockwrite -n $cgsbsock silence $+(+,$gettok($mid($1,2,$len($1)),1,33))
      .timer -o 2 2 sockwrite -n $cgsbsock silence $+(-,$gettok($mid($1,2,$len($1)),1,33))
    }
  }
  elseif ($2 == privmsg && $left($3,1) == $chr(35)) {
    if (:action * iswm $4-) {
      cgsblog $cgsbsock $3 * [action] $gettok($mid($1,2,$len($1)),1,33) $remove($5-,$chr(1))
    }
    elseif (:* iswm $4-) {
      cgsblog $cgsbsock $3 * [ctcp] $gettok($mid($1,2,$len($1)),1,33) $remove($5-,$chr(1))
    }
    else {
      var %n = $+($cgsbsock,.,$hget(cgsb,$+($cgsbsock,.network)),.,$3,.nicks)
      cgsblog $cgsbsock $3 $+(<,$remove($hget(%n,$gettok($mid($1,2,$len($1)),1,33)),-),$hget(%n,$mid($1,2,$len($1))),$gettok($mid($1,2,$len($1)),1,33),>) $mid($4-,2,$len($4-))
    }
  }
}
