;TITLE URL
;AUTHOR entropy
;COMMANDS url(0)
;VERSION: 1.1
;HELP url [-r] [wildcard]|Returns url matching wildcard. If you supply -r, then wildcard urls are removed.|none

;============================== ALIASES
alias -l compressedtime {
  return $remove($replace($duration($calc($ctime - $1)),wks,w,wk,w,days,d,day,d,hrs,h,hr,h,mins,m,min,m,secs,s,sec,s),$chr(32))
}
alias -l cgsbsock { return $hget(cgsb,socket) | halt }
;============================== EVENTS
on *:signal:url:{
  var %z = $hget(cgsb,buffer), %p = $hget(cgsb,$+($cgsbsock,.prefix))
  var %t = $gettok($hget(cgsb,$+($cgsbsock,.colors)),1,32), %u = $gettok($hget(cgsb,$+($cgsbsock,.colors)),2,32), %p = $hget(cgsb,$+($cgsbsock,.prefix))
  var %a = $hget($cgsbsock,access)
  tokenize 32 %z
  if ($2 == privmsg && $left($3,1) == $chr(35) && $+(:,%p,*) !iswm $4) {
    if (:http://* iswm $4 || :www.* iswm $4 || :ftp://* iswm $4) {
      var %url = $mid($4,2,$len($4)), %path = $+($cgsbsock,.,$hget(cgsb,$+($cgsbsock,.network)),.,$3)
      if (www.* iswm %url) { %url = $+(http://,%url) }
      if (%url == http://www. || %url == http:// || %url == ftp://) { return }
      if (!$hget($cgsbsock,$+(%path,.,%url))) {
        hadd -m $cgsbsock $+(%path,.,%url) $gettok($mid($1,2,$len($1)),1,33) $ctime
        sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ Url added. $chr(3)
      }
    }
  }
  elseif ($2 == privmsg && $left($3,1) == $chr(35) && $+(:,%p,*) iswm $4) {
    if ($+(:,%p,url) == $4) {
      if (%a < $getcom(url)) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ You do not posses enough access for this command. $chr(3) | return }
      var %path = $+($cgsbsock,.,$hget(cgsb,$+($cgsbsock,.network)),.,$3), %found, %a = $hget($cgsbsock,access)
      if (!$5) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ No wildcard specified. $chr(3) }
      elseif ($5 == -r) {
        if (%a <= 1) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ You do not posses enough access to use this command. $chr(3) }
        elseif (!$6) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ No wildcard specified. $chr(3) }
        else {
          var %a = 1, %b = $hfind($cgsbsock,$+(%path,.,*,$6,*),0,w).item, %c, %to = 0 
          while (%a <= %b) {
            %c = $hfind($cgsbsock,$+(%path,.,*,$6,*),%a,w).item
            inc %to
            if (%c) { hdel $cgsbsock %c }
            inc %a
          }
          if (%to > 0) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ A total of $+(,%to,) $iif(%to == 1,url,urls) deleted. $chr(3) }
          else { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ No urls found matching wildcard! $chr(3) }
        }
      }
      elseif ($hfind($cgsbsock,$+(%path,.,*,$5,*),0,w).item > 5) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ Search criteria too broad. $chr(3) }
      elseif ($hfind($cgsbsock,$+(%path,.,*,$5,*),1,w).item) {
        var %a = 1, %h = 0, %b
        while ($hfind($cgsbsock,$+(%path,.,*,$5,*),%a,w).item) {
          inc %h 2
          %found = $remove($ifmatch,$+(%path,.))
          %b = $hget($cgsbsock,$ifmatch)
          .timer -o 1 %h sockwrite -n $cgsbsock privmsg $3 $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ $+([,%a,] $chr(40),$gettok(%b,1,32),/,$compressedtime($gettok(%b,2,32)),$chr(41)) %found $chr(3)
          inc %a
        }
      }
      else { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ No url found. $chr(3) }
      sockwrite -n $cgsbsock silence $+(+,$gettok($mid($1,2,$len($1)),1,33))
      .timer -o 1 $iif(%a,%a,1) sockwrite -n $cgsbsock silence $+(-,$gettok($mid($1,2,$len($1)),1,33))
    }
  }
}
